<?php
/*
    gallery.class.php - contains TBL_Banner class description
*/

require_once "table.class.php"; //ICM_Table description

/*
    class TBL_Banner - class to work with Banner module database table
*/
class TBL_Banner extends ICM_Table
{
    /* methods:
    bool TBL_Banner()
    int insert(array data)
    bool update(int id, array data)
    */

/*
    constructor, mainly calles ICM_Table constructor
    receives nothing
    returnes true if succeed
*/
    function TBL_Banner()
    {
        $called=ICM_Table::ICM_Table($GLOBALS['TBL']['banners'], '_trans', 'banner', 'language');
        return $called;
    }

/*
    extends insert() method in ICM_Table class
    receives data to insert
    returnes inserted ID
*/
    function insert($data)
    {
		/*
			uploading image
		*/
    	$image_dir = $GLOBALS['PTH']['banners'];
    	$image_name = $data['src']['name'];
    	$image_tmp_name = $data['src']['tmp_name'];
		$image_path = $image_dir.$image_name;
		if (is_uploaded_file($image_tmp_name)) {
			$uploaded = move_uploaded_file($image_tmp_name, $image_path);
		}
		unset($data['src']);
		if ($uploaded) {
			$data['src'] = $image_name;
		}
		
		$User=new TBL_User;
        $data['created']=date('Y-m-d H:i:s', time());
        $data['modified']=date('Y-m-d H:i:s', time());
        $data['owner']=(empty($data['owner'])) ? $User->id_by_login($_SESSION['ses_login']) : null;
        $added=ICM_Table::insert($data);
        return $added;
    }

/*
    extends update() method in ICM_Table class
    receives row ID and data to update
    returnes true if succeed
*/
    function update($id, $data)
    {
    	$image_tmp_name = $data['src']['tmp_name'];
		if (is_uploaded_file($image_tmp_name)) {

			$image_dir = $GLOBALS['PTH']['banners'];
	
			/*
				deleting old image
			*/
			$src = $this->getValue($id, 'src');
			$image_in_use = (count($this->all("and `src`='$src'")) - 1) > 0;
			$image_path = $image_dir.$src;
			if (file_exists($image_path) && !$image_in_use) {
				unlink($image_path);
			}
	
			/*
				uploading image
			*/
	    	$image_name = $data['src']['name'];
			$image_path = $image_dir . $image_name;
	
			$uploaded = move_uploaded_file($image_tmp_name, $image_path);
		}
		unset($data['src']);
		if ($uploaded) {
			$data['src'] = $image_name;
		}
		
        $data['modified'] = date('Y-m-d H:i:s', time());
        $updated=ICM_Table::update($id, $data);
        return $updated;
    }
    
/*
	extends dalete() method in ICM_Table class
	receives row ID
	returnes true if succeed
*/    
	function delete($id)
	{
		$image_dir = $GLOBALS['PTH']['banners'];
		$src = $this->getValue($id, 'src');
		$image_in_use = (count($this->all("and `src`='$src'")) - 1) > 0;
		$image_path = $image_dir.$src;
		if (file_exists($image_path) && !$image_in_use) {
			unlink($image_path);
		}
		$deleted = ICM_Table::delete($id);
		return $deleted;
	}
}
?>