<?php
/*
    blocks.class.php - contains TBL_Block class description
*/

require_once "table.class.php";	//ICM_Table description
require_once "user.class.php";	//TBL_User description

/*
    class TBL_Block - class to work with Block module database table
*/
class TBL_Block extends ICM_Table
{
    /* methods:
    bool TBL_Block()
    int insert(array data)
    bool update(int id, array data)
    */

/*
    constructor, mainly calles ICM_Table constructor
    receives nothing
    returnes true if succeed
*/
    function TBL_Block()
    {
        $called=ICM_Table::ICM_Table($GLOBALS['TBL']['blocks'], '_trans', 'block', 'language');
        return $called;
    }

/*
    extends insert() method in ICM_Table class
    receives data to insert
    returnes inserted ID
*/
    function insert($data)
    {
        $User=new TBL_User;
        $data['created']=date('Y-m-d H:i:s', time());
        $data['modified']=date('Y-m-d H:i:s', time());
        $data['owner']=(empty($data['owner'])) ? $User->id_by_login($_SESSION['ses_login']) : null;
        $added=ICM_Table::insert($data);
        return $added;
    }

/*
    extends update() method in ICM_Table class
    receives row ID and data to update
    returnes true if succeed
*/
    function update($id, $data)
    {
        $data['modified']=date('Y-m-d H:i:s', time());
        $updated=ICM_Table::update($id, $data);
        return $updated;
    }
}
?>