<?php
/*
    db.class.php - contains ICM_DBase class description
*/

$GLOBALS['DB']=xparse_ini_file("{$GLOBALS['PTH']['conf']}dbase.conf", false);   //database configs

/*
    class ICM_DB - class to work with database
    implements work with mysql database
*/
class ICM_DB
{
    var $_link;     //link to mysql database
    var $_host;     //database host
    var $_login;    //database login
    var $_pass;     //database password
    var $_name;     //database name
    /* methods:
    bool ICM_DB()
    mixed exeQuery(string query)
    mixed getResult(string query)
    array getTables()
    array getFields(string table_name)
    int lastID()
    */

/*
    constructor, connects to database
    receives database attributes
    returnes true if connected
*/
    function ICM_DB()
    {
        $GLOBALS['DB_LINK_NUM'] ++;
        $this->_host=$GLOBALS['DB']['host'];
        $this->_login=$GLOBALS['DB']['login'];
        $this->_pass=$GLOBALS['DB']['pass'];
        $this->_name=$GLOBALS['DB']['name'];
        $this->_link=mysql_pconnect($this->_host,$this->_login,$this->_pass);
        return mysql_select_db($this->_name,$this->_link);
    }

/*
    executes mysql query
    receives given query
    returnes mysql result
*/
    function exeQuery($query)
    {
        $qid = md5($query);
        //$qid = preg_replace('/\s+/', ' ', $query);
        if (!in_array($qid, $GLOBALS['DB_CACHED_QUERIES'])) {
            $start = getmicrotime();
            $GLOBALS['DB_QUERY_NUM'] ++;
            if($GLOBALS['DB']['show_error']) {
                $result=mysql_query($query,$this->_link) or die("Error ".mysql_errno().': '.mysql_error()."<br />Query: ".nl2br($query));
            } else {
                $result=mysql_query($query,$this->_link);
            }
            array_push($GLOBALS['DB_CACHED_QUERIES'], $qid);
            $GLOBALS['DB_CACHED_RESULTS'][$qid] = $result;
            $end = getmicrotime();
            $GLOBALS['DB_QUERIES'][] = number_format($end - $start, 3) . '| ' . $query;
        } else {
            @mysql_data_seek($GLOBALS['DB_CACHED_RESULTS'][$qid], 0);
        }
        return $GLOBALS['DB_CACHED_RESULTS'][$qid];
    }

/*
    executes mysql query and returnes result
    receives string
    returnes result
*/
    function getResult($query)
    {
        $result=$this->exeQuery($query);
        $data=mysql_fetch_array($result);
        return $data[0];
    }

/*
    gets list of tables in current database
    receives nothing
    returnes names of tables
*/
    function getTables()
    {
        if (isset($_SESSION['DB_CACHED_TBL_LIST'])) {
            return $_SESSION['DB_CACHED_TBL_LIST'];
        } else {
            $tables_names=array();
            $tables=mysql_list_tables($this->_name, $this->_link);
            $property_name='Tables_in_'.$this->_name;
            while($table=mysql_fetch_object($tables))
                array_push($tables_names, $table->$property_name);
            $_SESSION['DB_CACHED_TBL_LIST'] = $tables_names;
            return $tables_names;
        }
    }

/*
    gets fields' names of a given table
    receives table name
    returnes fields names
*/
    function getFields($table)
    {
        if (isset($_SESSION['DB_CACHED_' . $table . '_FIELDS'])) {
            return $_SESSION['DB_CACHED_' . $table . '_FIELDS'];
        } else {
            $fields=mysql_list_fields($this->_name, $table, $this->_link);
            $fields_num=mysql_num_fields($fields);
            for($i=0; $i<$fields_num; $i++)
                $fields_names[$i+1]=mysql_field_name($fields, $i);
            $_SESSION['DB_CACHED_' . $table . '_FIELDS'] = $fields_names;
            return $fields_names;
        }
    }

/*
    gets id of last inserted row
    receives nothing
    return ID
*/
    function lastID()
    {
        return mysql_insert_id($this->_link);
    }
}
?>