<?php
/*
    group.class.php - contains TBL_Group class description
*/

require_once "table.class.php";	//ICM_Table description
require_once "user.class.php";	//TBL_User description

/*
    class TBL_Group - class to work with Groups module database table
*/
class TBL_Group extends ICM_Table
{
    /* methods:
    bool TBL_Content()
    int insert(array data)
    bool update(int id, array data)
    array getChildren(int id)
    array getParents(int id)
    int getLevel(int id)
    */

/*
    constructor, mainly calles ICM_Table constructor
    receives nothing
    returnes true if succeed
*/
    function TBL_Group()
    {
        $called=ICM_Table::ICM_Table($GLOBALS['TBL']['groups'], '_trans', 'group', 'language');
        return $called;
    }

/*
    extends insert() method in ICM_Table class
    receives data to insert
    returnes inserted ID
*/
    function insert($data)
    {
        $User=new TBL_User;
        $data['created']=date('Y-m-d H:i:s', time());
        $data['modified']=date('Y-m-d H:i:s', time());
        $data['owner']=(empty($data['owner'])) ? $User->id_by_login($_SESSION['ses_login']) : null;
        $added=ICM_Table::insert($data);
        return $added;
    }

/*
    extends update() method in ICM_Table class
    receives row ID and data to update
    returnes true if succeed
*/
    function update($id, $data)
    {
        $data['modified']=date('Y-m-d H:i:s', time());
        $updated=ICM_Table::update($id, $data);
        return $updated;
    }

/*
    gets all children of the group
    receives group ID
    returnes array of children IDs
*/
    function getChildren($id)
    {
        if($id!=null)
            $children=$this->all("and parent='$id' group by id");
        else
            $children=$this->all("and (parent is null or parent='0') group by id");
        return $children;
    }

/*
    gets all children of the group
    receives group ID
    returnes array of children IDs
*/
    function getParents($id)
    {
        $parents=array();
        $parent=$this->getValue($id, 'parent');
        while($parent)
        {
            array_push($parents, $parent);
            $parent=$this->getValue($parent, 'parent');
        }
        return $parents;
    }

/*
    gets parents number
    receives group ID
    returnes integer
*/
    function getLevel($id)
    {
        $parents=$this->getParents($id);
        $level=count($parents);
        return $level;
    }
}
?>