<?php
/*
    lang.class.php - contains TBL_Lang class description
*/

require_once "table.class.php";        //ICM_Table description
require_once "user.class.php";        //TBL_User description

/*
    class TBL_Lang - class to work with Languages module database table
*/
class TBL_Lang extends ICM_Table
{
    //bool TBL_Lang()
    //int id_by_name(string name)
    var $Langs;
    
/*
    constructor, mainly calles ICM_Table constructor
    receives nothing
    returnes true if succeed
*/
    function TBL_Lang()
    {
        $called=ICM_Table::ICM_Table($GLOBALS['TBL']['lang'], '_trans', 'language', 'language2trans');
        return $called;
    }

/*
    extends insert() method in ICM_Table class
    receives data to insert
    returnes inserted ID
*/
    function insert($data)
    {
		$User=new TBL_User;
        $data['created']=date('Y-m-d H:i:s', time());
        $data['modified']=date('Y-m-d H:i:s', time());
        $data['owner']=(empty($data['owner'])) ? $User->id_by_login($_SESSION['ses_login']) : null;
        $added=ICM_Table::insert($data);
        return $added;
    }

/*
    extends update() method in ICM_Table class
    receives row ID and data to update
    returnes true if succeed
*/
    function update($id, $data)
    {
        $data['modified']=date('Y-m-d H:i:s', time());
        $updated=ICM_Table::update($id, $data);
        return $updated;
    }    
    
/*
    deletes language with given ID and all info lineked to the language
    receives language ID
    returne true if succeed
*/
    function delete($id)
    {
        ICM_Table::delete($id);
        $tables=$this->db->getTables();
        foreach($tables as $table)
            if(preg_match('/_trans$/', $table))
                $this->db->exeQuery("delete from `$table` where language='$id'");
        return true;
    }

/*
    gets language id by its name
    receives language name
    returnes language id
*/
    function id_by_name($name)
    {
        $id=$this->all(" and `name`='$name'");
        return current($id);
    }
}
?>