<?php
/*
    menu.class.php - contains TBL_Menu class description
*/

require_once "table.class.php"; //ICM_Table description

/*
    class TBL_Menu - class to work with Menu module database table
*/
class TBL_Menu extends ICM_Table
{
    /* methods:
    bool TBL_Menu()
    int insert(array data)
    bool update(int id, array data)
    */
    var $Item;

/*
    constructor, mainly calles ICM_Table constructor
    receives nothing
    returnes true if succeed
*/
    function TBL_Menu()
    {
        $called = ICM_Table::ICM_Table($GLOBALS['TBL']['menus'], '_trans', 'menu', 'language');
        $this->Item = new Menu_Item;
        return $called;
    }

/*
    extends insert() method in ICM_Table class
    receives data to insert
    returnes inserted ID
*/
    function insert($data)
    {
        $User=new TBL_User;
        
        //setting items
        $items = $data['items'];
        unset($data['items']);
        
        $data['created'] = date('Y-m-d H:i:s', time());
        $data['modified'] = date('Y-m-d H:i:s', time());
        $data['owner'] = (empty($data['owner'])) ? $User->id_by_login($_SESSION['ses_login']) : null;
        $added = ICM_Table::insert($data);
        
        //inserting items
        if (isset($items)) {
            foreach ($items as $item) {
                $item['menu'] = $added;
                $this->Item->insert($item);
            }
        }
        
        return $added;
    }

/*
    extends update() method in ICM_Table class
    receives row ID and data to update
    returnes true if succeed
*/
    function update($id, $data)
    {
        //setting items
        $items = $data['items'];
        unset($data['items']);
        
        $data['modified']=date('Y-m-d H:i:s', time());
        $updated=ICM_Table::update($id, $data);

        //updating items
        if (isset($items)) {
            $ids = array();
            foreach ($items as $item) {
                $item['menu'] = $id;
                if (isset($item['id']) && $this->exists($item['id'])) {
                    $this->Item->update($item['id'], $item);
                } else {
                    unset($item['id']);
                    $item['id'] = $this->Item->insert($item);
                }
                array_push($ids, $item['id']);
            }
            $ids_str = implode(',', $ids);
            $query = "delete from `{$this->Item->_name}`
                      where `id` not in ($ids_str) and {$this->_item}='$id'";
            $this->db->exeQuery($query);
        }
        return $updated;
    }
    
    function selectAll()
    {
        $args = func_get_args();
        $test = new ICM_Table($GLOBALS['TBL']['menus'], '_trans', 'menu', 'language');
        $data = call_user_func_array(array(&$test, 'selectAll'), $args);
        $id_set = '0';
        $data_by_id = array();
        foreach ($data as $key => $row) {
            $id_set .= ", '" . $row['id'] . "'";
            $data_by_id[$row['id']] = $row;
            $data_by_id[$row['id']]['items'] = array();
        }
        
        $items = $this->Item->selectAll(null, null, 'order_id', 'asc', "and `{$this->_item}` in ($id_set)");
        foreach ($items as $item) {
            $data_by_id[$item[$this->_item]]['items'][] = $item;
        }
        
        $data = array();
        
        $i = 0;
        foreach ($data_by_id as $row) {
            $data[$i] = $row;
            $i ++;
        }

        return $data;
    }

    function select($id)
    {
        $data = ICM_Table::select($id);
        $data['items'] = $this->Item->selectAll(null, null, 'order_id', 'asc', "and `{$this->_item}`='$id'");
        return $data;
    }
}

/*
    class Menu_Item - class to work with Item module database table
*/
class Menu_Item extends ICM_Table
{
    /* methods:
    bool Menu_Item()
    */

/*
    constructor, mainly calles ICM_Table constructor
    receives nothing
    returnes true if succeed
*/
    function Menu_Item()
    {
        $called = ICM_Table::ICM_Table($GLOBALS['TBL']['menuitems'], '_trans', 'item', 'language');
        return $called;
    }

}
?>