<?php
/*
    poll.class.php - contains TBL_Poll class description
*/

require_once "table.class.php"; //ICM_Table description

/*
    class TBL_Poll - class to work with Poll module database table
*/
class TBL_Poll extends ICM_Table
{
    /* methods:
    bool TBL_Poll()
    int insert(array data)
    bool update(int id, array data)
    */
    var $Answer;

/*
    constructor, mainly calles ICM_Table constructor
    receives nothing
    returnes true if succeed
*/
    function TBL_Poll()
    {
        $called = ICM_Table::ICM_Table($GLOBALS['TBL']['polls'], '_trans', 'poll', 'language');
        $this->Answer = new Poll_Answer;
        return $called;
    }

/*
    extends insert() method in ICM_Table class
    receives data to insert
    returnes inserted ID
*/
    function insert($data)
    {
        $User=new TBL_User;
        
        //setting answers
        $answers = $data['answers'];
        unset($data['answers']);
        
        $data['created'] = date('Y-m-d H:i:s', time());
        $data['modified'] = date('Y-m-d H:i:s', time());
        $data['owner'] = (empty($data['owner'])) ? $User->id_by_login($_SESSION['ses_login']) : null;
        $added = ICM_Table::insert($data);
        
        //inserting answers
        if (isset($answers)) {
            foreach ($answers as $answer) {
                $answer['poll'] = $added;
                $this->Answer->insert($answer);
            }
        }
        
        return $added;
    }

/*
    extends update() method in ICM_Table class
    receives row ID and data to update
    returnes true if succeed
*/
    function update($id, $data)
    {
        //setting answers
        $answers = $data['answers'];
        unset($data['answers']);
        
        $data['modified']=date('Y-m-d H:i:s', time());
        $updated=ICM_Table::update($id, $data);

        //updating answers
        if (isset($answers)) {
            $ids = array();
            foreach ($answers as $answer) {
                $answer['poll'] = $id;
                if (isset($answer['id']) && $this->exists($answer['id'])) {
                    $this->Answer->update($answer['id'], $answer);
                } else {
                    unset($answer['id']);
                    $answer['id'] = $this->Answer->insert($answer);
                }
                array_push($ids, $answer['id']);
            }
            $ids_str = implode(',', $ids);
            $query = "delete from `{$this->Answer->_name}`
                      where `id` not in ($ids_str) and {$this->_item}='$id'";
            $this->db->exeQuery($query);
        }
        return $updated;
    }
    
    function selectAll()
    {
        $args = func_get_args();
        $test = new ICM_Table($GLOBALS['TBL']['polls'], '_trans', 'poll', 'language');
        $data = call_user_func_array(array(&$test, 'selectAll'), $args);
        $id_set = '0';
        $data_by_id = array();
        foreach ($data as $key => $row) {
            $id_set .= ", '" . $row['id'] . "'";
            $data_by_id[$row['id']] = $row;
            $data_by_id[$row['id']]['answers'] = array();
        }
        
        $answers = $this->Answer->selectAll("and `{$this->_item}` in ($id_set)");
        foreach ($answers as $answer) {
            $data_by_id[$answer[$this->_item]]['answers'][] = $answer;
        }
        
        $data = array();
        
        $i = 0;
        foreach ($data_by_id as $row) {
            $data[$i] = $row;
            $i ++;
        }

        return $data;
    }
    
    function select($id)
    {
        $data = ICM_Table::select($id);
        $data['answers'] = $this->Answer->selectAll("and `{$this->_item}`='$id'");
        return $data;
    }
    
    function vote($poll, $answer)
    {
        $query = "update `{$this->Answer->_name}`
                  set `votes` = `votes` + 1
                  where `id` = '$answer'";
        return $this->db->exeQuery($query);
    }
    
    function totalVotes($id)
    {
        $query = "select sum(votes)
                  from `{$this->Answer->_name}`
                  where `{$this->_item}` = '$id'";
        return $this->db->getResult($query);
    }

    function maxVotes($id)
    {
        $query = "select max(votes)
                  from `{$this->Answer->_name}`
                  where `{$this->_item}` = '$id'";
        return $this->db->getResult($query);
    }
}

/*
    class Poll_Answer - class to work with Answer module database table
*/
class Poll_Answer extends ICM_Table
{
    /* methods:
    bool Poll_Answer()
    */

/*
    constructor, mainly calles ICM_Table constructor
    receives nothing
    returnes true if succeed
*/
    function Poll_Answer()
    {
        $called = ICM_Table::ICM_Table($GLOBALS['TBL']['pollans'], '_trans', 'ans', 'language');
        return $called;
    }

}
?>