<?php
/*
    session.class.php - contains ICM_Session class description
*/

require_once "table.class.php"; //ICM_DB class description

/*
    class ICM_Session - class for session handling
*/
class ICM_Session
{
    var $db;         //database object
    var $_table;     //session table
    var $_lifetime;  //session lifetime
    /* methods:
    void ICM_Session()
    bool open()
    bool close()
    mixed read(int id)
    bool write(int id, mixed value)
    bool destroy(int id)
    bool gc(int lifetime)
    */

/*
    constructor, sets session handlers
    receives nothing
    returnes nothing
*/
    function ICM_Session()
    {
        if($GLOBALS['CONF']['ses_type']=='dbase')
            session_set_save_handler(
            array(&$this, 'open'),
            array(&$this, 'close'),
            array(&$this, 'read'),
            array(&$this, 'write'),
            array(&$this, 'destroy'),
            array(&$this, 'gc')
            );
        session_start();
    }

/*
    initializes session
    receives nothing
    returnes true
*/
    function open()
    {
        $this->db = $GLOBALS['DB_CLASS_INSTANCE'];
        $this->_lifetime=ini_get('session.gc_maxlifetime');
        $this->_table=$GLOBALS['TBL']['sessions'];
        return true;
    }

/*
    closes session
    receives nothing
    returnes true
*/
    function close()
    {
        return true;
    }

/*
    reads session data
    receives session ID
    returnes mixed data
*/
    function read($id)
    {
        $query="select value from `{$this->_table}` where `id`='$id'";
        $result=$this->db->exeQuery($query);
        $data=mysql_fetch_assoc($result);
        return $data['value'];
    }

/*
    writes session data
    receives session ID and value to put
    returnes true if succeed
*/
    function write($id, $value)
    {
        $value = mysql_real_escape_string($value);
        $expiration=time()+$this->_lifetime;
        $query="replace into `{$this->_table}`
                 (`id`, `expiration`, `value`)
                values
                 ('$id', '$expiration', '$value')";
        return $this->db->exeQuery($query);
    }

/*
    destroys session
    receives session ID
    returnes true if succeed
*/
    function destroy($id)
    {
        $query="delete from `{$this->_table}` where `id`='$id'";
        return $this->db->exeQuery($query);
    }

/*
    garbage collector, delete "old" sessions
    receives lifetime
    returnes true if succeed
*/
    function gc($lifetime)
    {
        $life_period=time()-$lifetime;
        $query="delete from `{$this->_table}` where `expiration`<'$life_period'";
        return $this->db->exeQuery($query);
    }
}
?>