<?php
/*
    user.class.php - contains TBL_User class description
*/

require_once "table.class.php";

/*
    class TBL_User - class to work with Users module database table
*/
class TBL_User extends ICM_Table
{
    /* methods:
    bool TBL_Content()
    int insert(array data)
    bool update(int id, array data)
    */

/*
    constructor, mainly calles ICM_Table constructor
    receives nothing
    returnes true if succeed
*/
    function TBL_User()
    {
        $called=ICM_Table::ICM_Table($GLOBALS['TBL']['users'], '_trans', 'user', 'language');
        return $called;
    }

/*
    extends insert() method in ICM_Table class
    receives data to insert
    returnes inserted ID
*/
    function insert($data)
    {
        $data['created']=date('Y-m-d H:i:s', time());
        $data['modified']=date('Y-m-d H:i:s', time());
        $data['pass']=md5($data['pass']);
        $data['owner']=(empty($data['owner'])) ? $this->id_by_login($_SESSION['ses_login']) : null;
        unset($data['pass2']);
        $added=ICM_Table::insert($data);
        return $added;
    }

/*
    extends update() method in ICM_Table class
    receives row ID and data to update
    returnes true if succeed
*/
    function update($id, $data)
    {
        $data['modified']=date('Y-m-d H:i:s', time());
        if(strlen($data['pass']))
        {
            $data['pass']=md5($data['pass']);
            unset($data['pass2']);
        }
        else
        {
            unset($data['pass']);
            unset($data['pass2']);
        }
        $updated=ICM_Table::update($id, $data);
        return $updated;
    }

/*
    gets user ID by it's login
    receives user login
    returnes user ID
*/
    function id_by_login($login)
    {
        $id=$this->all(" and `login`='$login'");
        return current($id);
    }
}
?>