<?php
//common.func.php - common functions

function getVar($array, $index, $default=null)
{
    //gets value from an array by index
    //receives array, index and default value
    //returnes array element if exists, otherwise returnes default value
    if (isset($array[$index])) {
        return $array[$index];
    } else {
        return $default;
    }
}

function getFormVar($index, $default=null)
{
    //gets value from $_POST or $_GET
    //receives index, default value
    //returnes value or default value if doesn't exists
    $value = getVar($_POST, $index, getVar($_GET, $index, $default));
    if (!get_magic_quotes_gpc()) {
        $value = mysql_escape_string($value);
    }
    return $value;
}

function include_langfile($file, $lang)
{
    //includes language file
    //receives file name, language name
    //returnes nothing
    $ext = '.lang.conf';
    if (!isset($GLOBALS['LANG'])) {
        $GLOBALS['LANG'] = array();
    }
    $file_path = $GLOBALS['PTH']['langs'] . $lang . '/' . $file . $ext;
    if (file_exists($file_path)) {
        $GLOBALS['LANG'] = array_merge_recursive($GLOBALS['LANG'], xparse_ini_file($file_path, true));
    } else {
        $file_path = $GLOBALS['PTH']['langs'] . $GLOBALS['CONF']['admin_def_lang'] . '/' . $file . $ext;
        if (file_exists($file_path)) {
            $GLOBALS['LANG'] = array_merge_recursive($GLOBALS['LANG'], xparse_ini_file($file_path, true));
        } else {
            make_error($GLOBALS['LANG']['error']['no_langfile'] . ' - ' . $file . $ext);
        }
    }
}
function make_error($error)
{
    //outputs error message
    //receives error message
    //returnes nothing
    if (!strlen($error)) {
        echo "<font color=\"#990000\">$error</font>";
    } else {
        echo '<font color="#990000">Error cannot be outputed, no language file included</font>';
    }
}

function atrb2str($atrb)
{
    //gets string value of attributes
    //receives attributes in number form
    //returnes attributes in string form
    $letters=array('v', 'e', 'd');
    $atrb_str='';
    $len=strlen($atrb);
    for($i=0; $i<$len; $i++)
    {
        $num=$atrb{$i};
        $num_bin=decbin($num);
        $num_bin=str_pad($num_bin, 3, '0', STR_PAD_LEFT);
        for($j=2; $j>=0; $j--)
            $atrb_str.=(($num_bin{$j}) ? $letters[2-$j] : '-');
    }
    return $atrb_str;
}

function date4sql($date)
{
        //converts date to mysql format
        //receives a string
        //returns a string
        $parts=explode('.',$date);
        $flipped_date=$parts[2].'-'.$parts[1].'-'.$parts[0];
        return $flipped_date;
}

function localeDate($str)
{
    $from_months = array('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December');
    $from_months_short = array('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
    $from_days = array('Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday', 'Sunday');
    $from_days_short = array('Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun');

    $to_months = array();
    foreach ($from_months as $month) {
        $to_months[] = $GLOBALS['LANG']['month'][$month];
    }
    
    $to_months_short = array();
    foreach ($from_months_short as $month) {
        $to_months_short[] = $GLOBALS['LANG']['month'][$month];
    }
    
    $to_days = array();
    foreach ($from_days as $day) {
        $to_days[] = $GLOBALS['LANG']['day'][$day];
    }
    
    $to_days_short = array();
    foreach ($from_days_short as $day) {
        $to_days_short[] = $GLOBALS['LANG']['day'][$day];
    }
        
    $from = $from_months + $from_months_short + $from_days + $from_days_short;
    $to = $to_months + $to_months_short + $to_days + $to_days_short;
    
    return str_replace($from, $to, $str);
}

function date4user($date, $format = 'd.m.Y')
{
        //converts date to user's format
        //receives a string
        //returns a string
        $flipped_date = date($format, strtotime($date));
        $flipped_date = localeDate($flipped_date);
        return $flipped_date;
}


function email($to, $subj, $msg, $headers = null, $params = null)
{
    $done = @mail($to, $subj, $msg, $headers, $params);
    if (!$done) {
        $input =
<<<XML
<?xml version="1.0"?>
<mail>
  <subject>
    $subj
  </subject>
  <headers>
    $headers
  </headers>
  <message>
    $msg
  </message>
  <parameters>
    $params
  </parameters>
</mail>
XML;
        $dir = $GLOBALS['PTH']['email'] . $to . '/';
        if (!file_exists($dir)) {
            mkdir($dir, '0775');
        }
        if (file_exists($dir))
        {
            $words = preg_split('/\W/', $subj);
            $fname = (strlen($words[0])) ? $words[0] : 'untitled';
            $uname = $fname; //unique file name
            $i = '';
            while (file_exists($dir.$uname)) {
                $i = (int)$i;
                $i ++;
                $uname = $fname . '(' . $i .')';
            }
            $fname = $uname;
            $fh = fopen($dir.$fname, 'w');
            $done = fwrite($fh, $input);
            fclose($fh);
        }
    }
    return $done;
}

function goLocation($location)
{
    //redirects to a given location
    //receives location
    //returnes nothing
    if (!headers_sent()) {
        header("Location: $location");
        exit;
    } else {
        die('<script type="text/javascript">window.location = "' . $location . '";</script>');
    }
}

/**
 * generates short text
 * @param string $txt
 * @param int $num
 * @param string $mode
 * @return string $short
 */
function txt2short($txt, $num, $mode)
{
    switch ($mode) {
        default: case 's':
            $short = substr($txt, 0, $num);
            break;
        case 'w':
            $words = preg_split('/[\s\.,;:!?]+/', $txt);
            $words = array_slice($words, 0, $num);
            $short = implode(' ', $words);
            break;
        case 'p':
            $words = explode("\n", $txt);
            $words = array_slice($words, 0, $num);
            $short = implode(' ', $words);
            break;
    }
    return $short;
}

function translit($str)
{
    $cyr = array('', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', ' ');
    $lat = array('a', 'b', 'v', 'g', 'd', 'e', 'jo', 'zh', 'z', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'r', 's', 't', 'u', 'f', 'h', 'c', 'ch', 'sh', 'sch', '', 'y', '', 'e', 'ju', 'ja', '-');
    $str = strtolower($str);
    return str_replace($cyr, $lat, $str);
}
?>