<?php
//groups.func.php - Groups module functions
require_once "{$GLOBALS['PTH']['classes']}group.class.php";

function grp_test_parent($parent, $id)
{
    //tests group parent for validation
    //receives parent ID, group ID
    //returnes false if data is OK, error message otherwise
    $Access=new ICM_Access;
    $Group=new TBL_Group;
    if($Group->select($parent))
    {
        if(!empty($id))
        {
            $forbidden=array($id);
            $forbidden = array_merge($forbidden, $Group->getChildren($id));
            if(in_array($parent, $forbidden))
                return $GLOBALS['LANG']['error']['parent_is_child'];
        }

        $owner=$Group->getValue($parent, 'owner');
        $attr=$Group->getValue($parent, 'attributes');
        if(!($Access->is_allowed($owner, $attr, EDIT)))
            return $GLOBALS['LANG']['error']['group_denied'];

    }
    elseif(!empty($parent)) return $GLOBALS['LANG']['error']['parent_not_exists'];
    return false;
}

function grp_title($id)
{
    //gets group title
    //receives ID
    //returnes title
    global $sys_lang;
    $Lang=new TBL_Lang;
    $Group=new TBL_Group;
    return $Group->getTValue($id, $Lang->id_by_name($sys_lang), 'title');
}

function grp_access($id)
{
    $Access=new ICM_Access;
    $Group=new TBL_Group;
    $owner=$Group->getValue($id, 'owner');
    $attr=$Group->getValue($id, 'attributes');
    if($Access->is_allowed($owner, $attr, EDIT)) return false;
    else return $GLOBALS['LANG']['error']['group_denied'];
}
?>