<?php
//js.func.php - generates JavaScript functions

require_once "{$GLOBALS['PTH']['classes']}lang.class.php";
require_once "common.func.php";

//string error_empty(string title)
//string js_save(array data_struct)
//string js_regChange()
//string js_markRow()
//string js_checkBox()
//string js_checkAll()
//string js_markAll()
//string js_View()
//string js_Edit()
//string js_Add()
//string js_Delete()
//string js_Reset()
//string js_Cancel()
//string js_Go()
//string js_showData()
//string js_toggleTransData()
//string js_setFilter()
//string js_clearFilter()
//string js_ShowLocate()
//string js_Show()
//string js_Hide()
//string js_setButtons()
//string js_pickGroup()
//string js_clearPick()

function error_empty($title)
{
    //generates error with given title
    //receives title
    //returnes error message
    $error_msg=" - $title is missing";
    return $error_msg;
}

function js_Save($data_struct)
{
    //generates save function
    //receives data structure
    //returnes string
    $Lang=new TBL_Lang;
    $langs=$Lang->all();
    $js="
function Save()
{
    var errors='';";
    foreach($data_struct as $record)
    {
        if($record['not_empty'])
        if(!$record['translatable'])
        $js.="
    if (e = document.form_content.{$record['name_form']})
        if (!e.value) {
            var el = document.getElementById('title_{$record['name_form']}');
            el.className = el.className.replace('-highlight', '');
            el.className += '-highlight';
            errors += '\\n".error_empty($record['title'])."';
        }";
        else
        {
            $js.="
    test = false;";
            foreach($langs as $lang_id)
            $js.="
    if (e = document.form_content.{$record['name_form']}_$lang_id)
        if (e.value)
            test = true;";
            $js.="
    if (!test) {
        var el = document.getElementById('title_{$record['name_form']}');
        el.className = el.className.replace('-highlight', '');
        el.className += '-highlight';
        errors += '\\n".error_empty($record['title'])."';
    }";
        }
    }
    $js.="
    if (errors) {
        errors = 'Error:' + errors;
        window.alert(errors);
    } else {
        document.form_content.submit();
    }
}";
    return $js;
}

function js_regChange()
{
    //generates regChange function
    //receives nothing
    //returnes string - JavaScript code
    $js="
function regChange(e)
{
    name = e.name;
    if (!(td = document.getElementById('title_' + name))) {
        name = name.substring(0, name.lastIndexOf('_'));
        td = document.getElementById('title_'+name);
    }
    td.className = td.className.replace('-hightlight$', '');
    document.form_content.changed.value = 'true';
}";
    return $js;
}

function js_markRow()
{
    //generates markRow function
    //receives nothing
    //returnes string - JavaString code
    $js="
function markRow(id)
{
    if(e=document.getElementById('tr_'+id))
        if(chb=document.getElementsByName('check_'+id))
            if(chb[0].checked) e.className='highlight';
            else e.className='';
}";
    return $js;
}

function js_checkBox()
{
    //generates checkBox function
    //receives nothing
    //returnes string - JavaString code
    $js="
function checkBox(id)
{
    if(chb=document.getElementsByName('check_'+id))
        if(chb[0].checked) chb[0].checked=false;
        else chb[0].checked=true;
}";
    return $js;
}

function js_checkAll()
{
    //generates checkAll function
    //receives nothing
    //returnes string - JavaString code
    $js="
function checkAll()
{
    if(chb=document.getElementsByName('check_main'))
    {
        if(chb[0].checked) check=true;
        else check=false;
        num=document.form_content.length;
        for(var i=0; i<num; i++)
        {
            e=document.form_content[i];
            if(e.name.substring(0, e.name.indexOf('_'))=='check' && e.name!='check_main')
                e.checked=check;
        }
    }
}";
    return $js;
}

function js_markAll()
{
    //generates markAll function
    //receives nothing
    //returnes string - JavaString code
    $js="
function markAll()
{
    if(chb=document.getElementsByName('check_main'))
    {
        num=document.form_content.length;
        for(var i=0; i<num; i++)
        {
            e=document.form_content[i];
            if(e.name.substring(0, e.name.indexOf('_'))=='check' && e.name!='check_main')
            {
                id=e.name.substring(e.name.lastIndexOf('_')+1, e.name.length);
                if(tr=document.getElementById('tr_'+id))
                    if(e.checked) tr.className='highlight';
                    else tr.className='';
            }
        }
    }
}";
    return $js;
}

function js_View()
{
    //generates View function
    //receives nothing
    //returnes string - JavaString code
    $js="
function View(e)
{
    name=e.name;
    if(!name || name=='undefined') name=e.id;
    e_value=document.getElementsByName(name+'_value');
    id=e_value[0].value;
    window.location='~view?id='+id;
}";
    return $js;
}

function js_Edit()
{
    //generates Edit function
    //receives nothing
    //returnes string - JavaString code
    $js="
function Edit(e)
{
    name=e.name;
    if(!name || name=='undefined') name=e.id;
    e_value=document.getElementsByName(name+'_value');
    id=e_value[0].value;
    window.location='~edit?id='+id;
}";
    return $js;
}

function js_Add()
{
    //generates Add function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function Add(e)
{
    if(e)
    {
        name=e.name;
        if(!name || name=='undefined') name=e.id;
        e_value=document.getElementsByName(name+'_value');
        id=e_value[0].value;
        window.location='~add?id='+id;
    }
    else window.location='~add';
}";
    return $js;
}

function js_Delete()
{
    //generates Delete function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function Delete(e)
{
    if(window.confirm('{$GLOBALS['LANG']['confirm']['delete']}'))
    {
        name=e.name;
        if(!name || name=='undefined') name=e.id;
        e_value=document.getElementsByName(name+'_value');
        id=e_value[0].value;
        window.location='~del?id='+id;
    }
}";
    return $js;
}
function js_DeleteChecked()
{
    //generates DeleteChecked function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function DeleteChecked(params)
{
    if(window.confirm('{$GLOBALS['LANG']['confirm']['delete']}'))
    {
        document.form_content.action='~del';
        document.form_content.submit();
    }
}";
    return $js;
}

function js_resetForm()
{
    //generates ResetForm function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function resetForm()
{
    var to_reset=false;
    if(e=document.form_content.changed)
        if(e.value)
        {
            if(window.confirm('{$GLOBALS['LANG']['confirm']['reset']}'))
                to_reset=true;
        }
        else to_reset=true;
    else to_reset=true;

    if(to_reset)
    {
        document.form_content.reset();
        document.form_content.changed.value=null;
    }

}";
    return $js;
}

function js_Cancel($goto)
{
    //generates Cancel function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function Cancel()
{
    var to_cancel=false;
    if(e=document.form_content.changed)
        if(e.value)
        {
            if(window.confirm('{$GLOBALS['LANG']['confirm']['cancel']}'))
                to_cancel=true;
        }
        else to_cancel=true;
    else to_cancel=true;

    if(to_cancel) window.location='$goto';
}";
    return $js;
}

function js_Go()
{
    //generates Go function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function Go(s)
{
    window.location=s;
}";
    return $js;
}

function js_showData()
{
    //generates showData function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function showData(t)
{
    general=document.getElementById('data_general');
    general_s=document.getElementById('switch_general');
    system=document.getElementById('data_system');
    system_s=document.getElementById('switch_system');
    attributes=document.getElementById('data_attributes');
    attributes_s=document.getElementById('switch_attributes');
    if(general)
    {
        general.style.visibility='hidden';
        general.style.display='none';
        general_s.className='switch-data';
    }
    if(system)
    {
        system.style.visibility='hidden';
        system.style.display='none';
        system_s.className='switch-data';
    }
    if(attributes)
    {
        attributes.style.visibility='hidden';
        attributes.style.display='none';
        attributes_s.className='switch-data';
    }
    if(eval(t))
    {
        eval(t+'.style.visibility=\'visible\'');
        eval(t+'.style.display=\'block\'');
        eval(t+'_s.className=\'switch-data-cur\'');
    }
}";
    return $js;
}

function js_setData()
{
    //generates setData function
    //receive nothing
    //returnes string - JavaScript code
    $js="
//function setData()
{
    showData('general');
    var divs=new Array();
    divs[1]=document.getElementById('data_general');
    divs[2]=document.getElementById('data_system');
    divs[3]=document.getElementById('data_attributes');
    max=0;
    for(var i=1; i<divs.length; i++)
    {
        if(max<divs[i].offsetHeight) max=divs[i].offsetHeight;
//        alert(divs[i].offsetWidth+':'+divs[i].offsetHeight);
    }
    for(var i=1; i<divs.length; i++)
        divs[i].style.height=max;
}";
    return $js;
}

function js_toggleTransData()
{
    //generates Go function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function toggleTransData(td)
{
    if(e=document.getElementById(td))
        if(e.style.display!='none')
            e.style.display='none';
        else
            e.style.display='block';
}";
    return $js;
}

function js_setFilter()
{
    //generates setFilter function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function setFilter(field, value)
{
    e=document.getElementsByName('sys_ffield');
    e[0].value=field;
    e=document.getElementsByName('sys_fvalue');
    e[0].value=value;
    e=document.getElementsByName('fquery');
    e[0].value=field+' = '+value;
}";
    return $js;
}

function js_clearFilter()
{
    //generates clearFilter function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function clearFilter()
{
    e=document.getElementsByName('sys_ffield');
    e[0].value='';
    e=document.getElementsByName('sys_fvalue');
    e[0].value='';
    e=document.getElementsByName('fquery');
    e[0].value='';
}";
    return $js;
}

function js_ShowLocate()
{
    //generates ShowLocate function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function ShowLocate(id, ev)
{
    if(e=document.getElementById(id))
    {
        if (e.style.visibility != 'visible') {
            e.style.visibility = 'visible';
        }
        if (e.style.display != 'block') {
            e.style.display = 'block';
        }
    	var pos = getCursorPosition(ev);
    	var posX = pos.x;
    	var posY = pos.y

        if (posX + e.offsetWidth >= window.screen.width) {
            e.style.left = (posX - e.offsetWidth) + 'px';
        } else {
            e.style.left = posX + 'px';
        }

        if (posY >= window.screen.height) {
            e.style.top = (posY - e.offsetHeight) + 'px';
        } else {
            e.style.top = posY + 'px';
        }
    }
}";
    return $js;
}

function js_showContextMenu()
{
    //generates showContextMenu function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function showContextMenu(id, ev)
{
    btn=(window.event ? window.event.button : ev.button);
    if (btn == 2) {
        if (e = document.getElementById('contextmenu_'+id)) {
            if(e.style.visibility!='visible') e.style.visibility='visible';
            if(e.style.display!='block') e.style.display='block';

        	var pos = getCursorPosition(ev);
        	var posX = pos.x;
        	var posY = pos.y

            if (posX + e.offsetWidth >= window.screen.width) {
                e.style.left = (posX - e.offsetWidth) + 'px';
            } else {
                e.style.left = posX + 'px';
            }

            if (posY >= window.screen.height) {
                e.style.top = (posY - e.offsetHeight) + 'px';
            } else {
                e.style.top = posY + 'px';
            }
            document.getElementById('ctmenu_showed').value=id;
            document.getElementById('tr_'+id).className='chosen';
        }
    }
}";
    return $js;
}

function js_hideContextMenu()
{
    //generates hideContextMenu function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function hideContextMenu()
{
    e=document.getElementById('ctmenu_showed');
    id=e.value;
    if(id>0)
    {
        Hide('contextmenu_'+id);
        markRow(id);
        e.value='0';
    }
}";
    return $js;
}

function js_hideBlocks()
{
    //generates hideBlocks function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function hideBlocks()
{
    divs=document.getElementsByTagName('DIV');
    num=divs.length;
    for(var i=0; i<num; i++)
    {
        id=divs[i].id;
        if(id.match('block_(.+)')) Minimize(id);
    }
}";
    return $js;
}

function js_setContextMenu()
{
    //generates setContextMenu function
    //receive nothing
    //returnes string - JavaScript code
    $js="
//function setContextMenu()
{
    body=document.getElementsByTagName('BODY');
    body[0].onclick=hideContextMenu;
}";
    return $js;
}

function js_Show()
{
    //generates Show function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function Show(id)
{
    if(e=document.getElementById(id))
        e.style.visibility='visible';
}";
    return $js;
}

function js_Hide()
{
    //generates Hide function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function Hide(id)
{
    if(e=document.getElementById(id))
        e.style.visibility='hidden';
}";
    return $js;
}

function js_Maximize()
{
    //generates Maximize function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function Maximize(id)
{
    if(e=document.getElementById(id))
        e.style.display='block';
}";
    return $js;
}

function js_Minimize()
{
    //generates Minimize function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function Minimize(id)
{
    if(e=document.getElementById(id))
        e.style.display='none';
}";
    return $js;
}

function js_setButtons()
{
    //generates Hide function
    //receive nothing
    //returnes string - JavaScript code
    $js="
//function setButtons()
{
    var btns=document.getElementsByTagName('INPUT');
    for(var i=0; i<btns.length; i++)
    {
        cls=btns[i].className;
        if(cls=='input-button')
        {
            btns[i].onmouseover=function(){this.className='input-button-hover';};
            btns[i].onmouseout=function(){this.className='input-button';};
            btns[i].onmousedown=function(){this.className='input-button-down'}
            btns[i].onmouseup=function(){this.className='input-button-hover'}
        }
    }

    var imgs=document.getElementsByTagName('IMG');
    for(var i=0; i<imgs.length; i++)
    {
        cls=imgs[i].className;
        if(cls=='input-image')
        {
            imgs[i].onmouseover=function(){this.className='input-image-hover';};
            imgs[i].onmouseout=function(){this.className='input-image';};
            imgs[i].onmousedown=function(){this.className='input-image-down'}
            imgs[i].onmouseup=function(){this.className='input-image-hover'}
        }
    }
}";
    return $js;
}

function js_pickGroup()
{
    //generates pickGroup function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function pickGroup(e)
{
    w_location='{$GLOBALS['URL']['home']}{$GLOBALS['URL']['tools']}pickgroup/?elem='+e;
    w_name='pickgroup';
    w_width=300;
    w_height=300;
    w_left=(window.innerWidth-w_width)/2;
    w_top=(window.innerHeight-w_height)/2;
    w=window.open(w_location, w_name, 'left='+w_left+', top='+w_top+', width='+w_width+', height='+w_height+', status=yes, resizable=yes, scrollbars=yes');
    w.focus();
}";
    return $js;
}

function js_pickSection()
{
    //generates pickSection function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function pickSection(e)
{
    w_location='{$GLOBALS['URL']['home']}{$GLOBALS['URL']['tools']}picksection/?elem='+e;
    w_name='picksection';
    w_width=300;
    w_height=300;
    w_left=(window.innerWidth-w_width)/2;
    w_top=(window.innerHeight-w_height)/2;
    w=window.open(w_location, w_name, 'left='+w_left+', top='+w_top+', width='+w_width+', height='+w_height+', status=yes, resizable=yes, scrollbars=yes');
    w.focus();
}";
    return $js;
}

function js_pickUser()
{
    //generates pickUser function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function pickUser(e)
{
    w_location='{$GLOBALS['URL']['home']}{$GLOBALS['URL']['tools']}pickuser/?elem='+e;
    w_name='pickuser';
    w_width=300;
    w_height=300;
    w_left=(window.innerWidth-w_width)/2;
    w_top=(window.innerHeight-w_height)/2;
    w=window.open(w_location, w_name, 'left='+w_left+', top='+w_top+', width='+w_width+', height='+w_height+', status=yes, resizable=yes, scrollbars=yes');
    w.focus();
}";
    return $js;
}

function js_clearPick()
{
    //generates clearPick function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function clearPick(name)
{
    e=document.getElementsByName(name);
    e[0].value='';
    e=document.getElementsByName(name+'_title');
    e[0].value='';
}";
    return $js;
}

function js_setPick()
{
    //generates setPick function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function setPick(value, title, elem)
{
    e=window.opener.document.getElementsByName(elem);
    e[0].value=value;
    e=window.opener.document.getElementsByName(elem+'_title');
    e[0].value=title;
    window.opener.focus();
}";
    return $js;
}

function js_toggleLayer()
{
    //generates toggleLayer function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function toggleLayer(name, id)
{
    if(e=document.getElementById(name+'_'+id))
        if(e.style.display!='block')
        {
            Maximize(name+'_'+id);
            e=document.getElementById('plusminus_'+id);
            e.innerHTML='<img src=\"{$GLOBALS['URL']['themes']}{$GLOBALS['CONF']['theme']}/icons/minus.gif\">';
        }
        else
        {
            Minimize(name+'_'+id);
            e=document.getElementById('plusminus_'+id);
            e.innerHTML='<img src=\"{$GLOBALS['URL']['themes']}{$GLOBALS['CONF']['theme']}/icons/plus.gif\">';
        }
}";
    return $js;
}

function js_toggleXTextArea()
{
    //generates toggleXTextArea function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function toggleXTextArea(e, name)
{
    elems = document.getElementsByName(name);
    if (elems[0].style.display != 'none') {
        elems[0].style.display = 'none';
        e.src ='{$GLOBALS['URL']['buttons']}maximize.gif';
    } else {
        elems[0].style.display = 'block';
        e.src ='{$GLOBALS['URL']['buttons']}minimize.gif';
    }
}";
    return $js;
}

function js_popXTextArea()
{
    //generates popXTextArea function
    //receive nothing
    //returnes string - JavaScript code
    $js="
function popXTextArea(name)
{
    w_location='{$GLOBALS['URL']['home']}{$GLOBALS['URL']['tools']}xtextarea/?name='+name;
    w_name='';
    w_width=600;
    w_height=400;
    w_left=(window.innerWidth-w_width)/2;
    w_top=(window.innerHeight-w_height)/2;
    w=window.open(w_location, w_name, 'left='+w_left+', top='+w_top+', width='+w_width+', height='+w_height+', status=yes, resizable=yes, scrollbars=yes');
    w.focus();

    elems=document.getElementsByName(name);
    elems[0].disabled=true;
    elems[0].onclick='new function{w.focus()}';
}";
    return $js;
}
function js_Remove()
{
    $js=
    <<<JS
function Remove(id)
{
    if(e=document.getElementById(id)) {
        e.parentNode.removeChild(e);
    }
}
JS;
    return $js;
}

function js_addPollAnswer()
{
    $Lang = new TBL_Lang;
    $sys_lang_id = $Lang->id_by_name($_SESSION[$GLOBALS['MODULE']['name'] . 'sys_lang']);
    $langs = $Lang->all();
    $langs_titles = array();
    foreach ($langs as $lang) {
        array_push($langs_titles, $Lang->getTValue($lang, $sys_lang_id, 'title'));
    }
    $langs_str = implode(', ', $langs);
    $langs_titles_str = "'".implode("', '", $langs_titles)."'";

    $js =
    <<<JS
function addPollAnswer(caller, id, val_ans, val_votes)
{
    /**
     *   [-] Remove answer
     *   Answer:
     *           Eng: <input class="input-text-long" name="answers[\$rnd][answer][\$eng_id]">
     *           Rus: <input class="input-text-long" name="answers[\$rnd][answer][\$rus_id]">
     *   Votes:  <input class="input-text-short" name="answers[\rnd][answer][\$lang]">
     */

    var langs = new Array($langs_str);
    var langs_titles = new Array($langs_titles_str);
    
    var rnd = id ? id : Math.round(Math.random() * 1e16);

    var div = document.createElement('div');
    div.className = 'div-answer';

    var btn = document.createElement('input');
    btn.type = 'button';
    btn.className = 'input-button';
    btn.value = '[-]'
    btn.onclick = function () {
        var parent = this.parentNode;
        parent.parentNode.removeChild(parent);
    }
    div.appendChild(btn);  
   
    div.appendChild(document.createElement('br'));

    var txt_lbl = document.createTextNode('{$GLOBALS['LANG']['field']['answer']}: ');
    div.appendChild(txt_lbl);
    div.appendChild(document.createElement('br'));
    
    for (var i = 0; i < langs.length; i++) {
        var div_in = document.createElement('div');
        var lang_lbl = document.createTextNode(langs_titles[i] + ': ');
        var txt = document.createElement('input');
        txt.className = 'input-text-long';
        txt.name = 'answers[' + rnd + '][answer][' + langs[i] + ']';
        if (val_ans && val_ans[langs[i]]) {
            txt.value = val_ans[langs[i]];
        }

        var span = document.createElement('span');
        span.className = 'span-answer';
        span.appendChild(lang_lbl);
        
        div_in.appendChild(span);
        div_in.appendChild(txt);
        div.appendChild(div_in);
    }
    div.appendChild(document.createElement('br'));
    
    var votes_lbl = document.createTextNode('{$GLOBALS['LANG']['field']['votes']}: ');  
    div.appendChild(votes_lbl);

    var votes = document.createElement('input');
    votes.className = 'input-text-short';
    votes.name = 'answers[' + rnd + '][votes]';
    if (val_votes) {
        votes.value = val_votes;
    }
    div.appendChild(votes);
    
    var container = caller.parentNode;
    container.appendChild(div);
}
JS;
    return $js;
}
function js_addMenuItem()
{
    $Lang = new TBL_Lang;

    $js =
    <<<JS
function addMenuItem(caller, id, title, value, order)
{
    /**
     *   [-] Remove section
     *   Answer: <input class="input-text-long" name="items[rnd][section]">
     *   Votes:  <input class="input-text-short" name="items[rnd][section]">
     */

    var rnd = id ? id : Math.round(Math.random() * 1e16);
    var order = order ? order : last_order + 1;
    last_order ++;

    var div = document.createElement('div');
    div.className = 'div-item';

    var btn = document.createElement('input');
    btn.type = 'button';
    btn.className = 'input-button';
    btn.value = '[-]'
    btn.onclick = function () {
        var parent = this.parentNode;
        parent.parentNode.removeChild(parent);
    }
    div.appendChild(btn);  
   
    div.appendChild(document.createTextNode(' '));

    var txt_lbl = document.createTextNode('{$GLOBALS['LANG']['field']['item']}: ');
    div.appendChild(txt_lbl);
    div.appendChild(document.createTextNode(' '));
    
    var txt = document.createElement('input');
    txt.className = 'input-text-long';
    txt.name = 'items[' + rnd + '][section]_title';
    txt.value = title ? title : '';
    txt.readonly = true;
    
    var hid = document.createElement('INPUT');
    hid.type = 'hidden';
    hid.name = 'items[' + rnd + '][section]';
    hid.value = value ? value : '';
    
    var hid_order = document.createElement('INPUT');
    hid_order.type = 'hidden';
    hid_order.name = 'items[' + rnd + '][order_id]';
    hid_order.value = order ? order : '';
    
    var btn_pick = document.createElement('INPUT');
    btn_pick.type = 'button';
    btn_pick.value = '...';
    btn_pick.className = 'input-button';
    btn_pick.onclick = function() {
        pickSection('items[' + rnd + '][section]');
    };
    
    var btn_clear = document.createElement('INPUT');
    btn_clear.type = 'button';
    btn_clear.value = 'x';
    btn_clear.className = 'input-button';
    btn_clear.onclick = function() {
        clearPick('items[' + rnd + '][section]');
    };
    
    div.appendChild(txt);
    div.appendChild(document.createTextNode(' '));
    div.appendChild(hid);
    div.appendChild(hid_order);
    div.appendChild(btn_pick);
    div.appendChild(document.createTextNode(' '));
    div.appendChild(btn_clear);

    div.appendChild(document.createElement('br'));
    
    var container = caller.parentNode;
    container.appendChild(div);
}
JS;
    return $js;
}
?>