<?php
//sections.func.php
require_once "{$GLOBALS['PTH']['classes']}section.class.php";

function section_test_parent($parent, $id)
{
    //tests section parent for validation
    //receives group ID, parent ID
    //returnes false if data is OK, error message otherwise
    $Section = new TBL_Section;
    if (!empty($id) && $id != HOME_ID) {
        if ($Section->select($parent)) {
            $forbidden = array($id);
            $forbidden = array_merge($forbidden, $Section->getChildren($id));
            if (in_array($parent, $forbidden)) {
                return $GLOBALS['LANG']['error']['parent_is_child'];
            }
        } elseif (!empty($parent)) {
            return $GLOBALS['LANG']['error']['parent_not_exists'];
        }
    } else {
        return $GLOBALS['LANG']['error']['empty_parent'];
    }
    return false;
}

function section_access($id)
{
    $Access=new ICM_Access;
    $Section=new TBL_Section;
    $owner=$Section->getValue($id, 'owner');
    $attr=$Section->getValue($id, 'attributes');
    if($Access->is_allowed($owner, $attr, EDIT)) return false;
    else return $GLOBALS['LANG']['error']['section_denied'];
}

function section_title($id)
{
    //gets section title
    //receives ID
    //returnes title
    global $sys_lang;
    $Lang=new TBL_Lang;
    $Section=new TBL_Section;
    return $Section->getTValue($id, $Lang->id_by_name($sys_lang), 'title');
}

function section_handler_title($handler)
{
    if (strpos($handler, ':') !== false) {
        list($type, $name) = explode(':', $handler, 2);
        $type_title = isset($GLOBALS['LANG']['label'][$type]) ? $GLOBALS['LANG']['label'][$type] : 'undefined type';
        $handler_title = isset($GLOBALS['LANG'][$type][$name]) ? $GLOBALS['LANG'][$type][$name] : $name;
        return $type_title . ': ' . $handler_title;
    } else {
        return $handler;
    }

}

function section_template_title($template)
{
    return isset($GLOBALS['LANG']['template'][$template]) ? $GLOBALS['LANG']['template'][$template] : $template;
}

function section_get_handlers()
{
    $option['']['opt_value'] = '';
    $option['']['opt_title'] = '';

    $scripts = section_get_scripts();
    foreach ($scripts as $key => $value) {
        $scripts[$key]['opt_value'] = 'script:' . $value['opt_value'];
        $scripts[$key]['opt_title'] = $GLOBALS['LANG']['label']['script'] . ': ' . $value['opt_title'];
    }

    $modules = section_get_modules();
    foreach ($modules as $key => $value) {
        $modules[$key]['opt_value'] = 'module:' . $value['opt_value'];
        $modules[$key]['opt_title'] = $GLOBALS['LANG']['label']['module'] . ': ' . $value['opt_title'];
    }

    return array_merge($option, $scripts, $modules);
}

function section_get_modules()
{
    $mods = array();
    $dh = opendir($GLOBALS['PTH']['mods']);
    while ($file = readdir($dh)) {
        if ($file != '.' && $file != '..' && is_dir($GLOBALS['PTH']['mods'].$file)) {
            array_push($mods, $file);
        }
    }
    
    foreach($mods as $key => $mod)
    {
        $option[$key]['opt_value'] = $mod;
        $option[$key]['opt_title'] = isset($GLOBALS['LANG']['module'][$mod])
                                   ? $GLOBALS['LANG']['module'][$mod] : $mod;
    }
    
    return $option;
}

function section_get_scripts()
{
    $scripts = glob($GLOBALS['PTH']['scripts'].'*.scr.php');
    foreach($scripts as $key => $script)
    {
        preg_match('/^(\w+)\.scr\.php$/', basename($script), $matches);
        $option[$key]['opt_value'] = $matches[1];
        $option[$key]['opt_title'] = isset($GLOBALS['LANG']['script'][$matches[1]])
                                   ? $GLOBALS['LANG']['script'][$matches[1]] : $matches[1];
    }
    
    return $option;
}

function section_get_templates()
{
    $tools = glob($GLOBALS['PTH']['themes'].$GLOBALS['CONF']['theme'].'/templates/*.tmpl');
    
    $option['']['opt_value'] = '';
    $option['']['opt_title'] = '';
    foreach($tools as $key => $tool)
    {
        preg_match('/^(\w+)\.tmpl$/', basename($tool), $matches);
        $option[$key]['opt_value'] = $matches[1];
        $option[$key]['opt_title'] = isset($GLOBALS['LANG']['template'][$matches[1]])
                                   ? $GLOBALS['LANG']['template'][$matches[1]] : $matches[1];
    }
    
    return $option;
}

function section_selectbox($path)
{
    global $sys_lang;
    
    $Lang = new TBL_lang;
    $Section = new TBL_Section;
    $sys_lang_id = $Lang->id_by_name($sys_lang);
    
    $option['']['opt_value'] = '';
    $option['']['opt_title'] = '';
    
    function makeTree($current, &$padding, &$option, $sys_lang_id)
    {
       
        $Section = new TBL_Section;
        
        $children = $Section->all("and `parent` = $current");
        $key = count($option);
        $option[$key]['opt_value'] = $current;
        $option[$key]['opt_title'] = $padding.$Section->getTValue($current, $sys_lang_id, 'title');

        if (count($children)) {
            foreach ($children as $child) {
                $t = $padding.'&nbsp;&nbsp;&nbsp;';
                makeTree($child, $t, $option, $sys_lang_id);
            }
        }
    }
    
    $padding = '';
    $root = $Section->IdByPath(explode('/', $path));
    makeTree($root, $padding, $option, $sys_lang_id);
    
    return $option;
}
?>