<?php
include "startup.php";  //include startup file, contains first instructions

//time watch start
$irokez_start = getmicrotime();

$Timer = new Timer;

$GLOBALS['DB_LINK_NUM'] = 0;
$GLOBALS['DB_QUERIES'] = array();
$GLOBALS['DB_QUERY_NUM'] = 0;
$GLOBALS['DB_CACHED_QUERIES'] = array();
$GLOBALS['DB_CACHED_RESULTS'] = array();

//get config variables
$GLOBALS += xparse_ini_file('path.conf', true);
$Timer->reg('parse path conf');

$GLOBALS['CONF'] = xparse_ini_file($GLOBALS['PTH']['conf'] . 'general.conf', true);
$Timer->reg('parse general conf');

//include class files
include $GLOBALS['PTH']['classes'] . 'icmtml.class.php';
include $GLOBALS['PTH']['classes'] . 'session.class.php';
include $GLOBALS['PTH']['classes'] . 'access.class.php';
include $GLOBALS['PTH']['classes'] . 'section.class.php';
include $GLOBALS['PTH']['classes'] . 'lang.class.php';

//include function files
include $GLOBALS['PTH']['func'] . 'common.func.php';
include $GLOBALS['PTH']['func'] . 'js.func.php';

//initiate classess
$GLOBALS['DB_CLASS_INSTANCE'] = new ICM_DB;
$Timer->reg('open connection');

$ICMTML   = new ICM_TML;
$Session  = new ICM_Session;
$Access   = new ICM_Access;
$Section  = new TBL_Section;
$Lang     = new TBL_Lang;

//get system variables
$GLOBALS['ENV']['path'] = $path = getVar($_GET, 'path');
$GLOBALS['ENV']['path'] = strchr($GLOBALS['ENV']['path'], '/');
$GLOBALS['ENV']['act']  = $act  = getVar($_GET, 'act');

$GLOBALS['all_langs'] = $langs = $Lang->selectAll();
$lang_names = array();
foreach ($langs as $lang) {
    $langs_by_name[$lang['name']] = $lang;
    $langs_by_id[$lang['id']] = $lang;
    array_push($lang_names, $lang['name']);
}
$GLOBALS['langs_by_name'] = $langs_by_name;
$GLOBALS['langs_by_id'] = $langs_by_id;

if ($GLOBALS['CONF']['single_lang']) {
    $sys_lang = $GLOBALS['CONF']['site_def_lang'];
    $sections = explode('/', HOME . '/' . $path);
} else {
    
    $sections = explode('/', $path);
    if (in_array($sections[0], $lang_names)) {
        $sys_lang = $sections[0];
        $sections[0] = HOME;
    }

    /*
        if language is not set, try to set user language,
        if fails set default language
    */
    if (!isset($sys_lang) || empty($sys_lang)) {
        ob_start();
        $accept_lang = $_SERVER['HTTP_ACCEPT_LANGUAGE'];
        if (in_array($accept_lang, $lang_names)) {
            $def_lang = $accept_lang;
        } else {
            $def_lang = $GLOBALS['CONF']['site_def_lang'];
        }
        ob_clean();
        header("Location: {$GLOBALS['URL']['main']}$def_lang/");
        exit;
    }
}
$Timer->reg('define language');

//if section is not set, gets default section
$cur_section = $Section->IdByPath($sections);
if (!$cur_section || $cur_section == $Section->IdByNameNParent(HOME, 0)) {
    $sections = explode('/', HOME . '/' . $GLOBALS['CONF']['def_section']);
    $cur_section = $Section->IdByPath($sections);
}

$level = $Section->getLevel($cur_section) + 1;
$extra = null;

if ($level < count($sections)){
    $extra = array_slice($sections , $level);
}

$Timer->reg('define current section');

//include language files
include_langfile('site', $sys_lang);
$Timer->reg('parse language file');

//authorization
if (isset($_POST['enter'])) {
    $redirect = str_replace('~logout', '', $_SERVER['REQUEST_URI']);
    $ok = $Access->login(getVar($_POST, 'login'), getVar($_POST, 'pass'), $err);
    $GLOBALS['ENV']['login_error'] = $err;
    $GLOBALS['ENV']['login'] = getVar($_POST, 'login');
    if ($ok) {
        header("Location: $redirect");
    }
} elseif ($act == 'logout') {
    $GLOBALS['ENV']['login_error'] = '1000';
    $Access->logout();
}

//set global variables
$GLOBALS['URL']['home']    = $GLOBALS['URL']['main'] . ($GLOBALS['CONF']['single_lang'] ? '' : $sys_lang . '/');
$GLOBALS['URL']['this']    = $GLOBALS['URL']['home'] . $Section->getPath($cur_section);

$GLOBALS['URL']['images']  = $GLOBALS['URL']['themes'] . $GLOBALS['CONF']['theme'] . '/images/';
$GLOBALS['URL']['icons']   = $GLOBALS['URL']['themes'] . $GLOBALS['CONF']['theme'] . '/icons/';
$GLOBALS['URL']['buttons'] = $GLOBALS['URL']['themes'] . $GLOBALS['CONF']['theme'] . '/buttons/';
$GLOBALS['URL']['js']      = $GLOBALS['URL']['themes'] . $GLOBALS['CONF']['theme'] . '/js/';
$GLOBALS['URL']['css']     = $GLOBALS['URL']['themes'] . $GLOBALS['CONF']['theme'] . '/css/';

$GLOBALS['ENV']['cur_section'] = $cur_section;
$GLOBALS['ENV']['extra']       = $extra;
$GLOBALS['ENV']['sys_lang_id'] = $sys_lang_id = isset($langs_by_name[$sys_lang]) ? $langs_by_name[$sys_lang]['id'] : 0;

/*
    if authorization succeed or not required load page contents
    else displays login page
*/
$auth_req = (bool) $Section->getValue($cur_section, 'authorization');
if (empty($auth_req) || ($auth_req && $Access->is_authorized($error))) {
    $tmpl_name = $Section->getValue($cur_section, 'template');
    if (!empty($tmpl_name)) {
        $tmpl_file = $GLOBALS['PTH']['themes'] . $GLOBALS['CONF']['theme'] . '/templates/' . $tmpl_name . '.tmpl';
    } else {
        $tmpl_file = $GLOBALS['PTH']['themes'] . $GLOBALS['CONF']['theme'] . '/templates/0.tmpl';
    }
    switch ($act) {
        default:
            $HTML = $ICMTML->parseTemplate($tmpl_file);
            break;
        case 'source':
            $HTML = $ICMTML->showSource($tmpl_file);
            break;
    }
} else {
    $tmpl_file = $GLOBALS['PTH']['themes'] . $GLOBALS['CONF']['theme'] . '/templates/login.tmpl';
    $HTML = $ICMTML->parseTemplate($tmpl_file);
}
$Timer->stop('generate page');

$irokez_end = getmicrotime();

$search = array(
    '{gen_time}',
    '{report}',
    '{connection_num}',
    '{query_num}',
    '{query_list}',
);

$replace = array(
    round($irokez_end - $irokez_start, 3),
    $Timer->report(),
    $GLOBALS['DB_LINK_NUM'],
    $GLOBALS['DB_QUERY_NUM'],
    print_r($GLOBALS['DB_QUERIES'], 1),
);

echo str_replace($search, $replace, $HTML);
?>