<?php
/**
 * gallery.scr.php - Gallery
 * Irokez CM script
 * 
 * @author Alexander Pak <irokez@gmail.com>
 * @copyright 2005 Alexander Pak
 * @license GNU/GPL <http://www.gnu.org/copyleft/gpl.html>
 */

require_once "{$GLOBALS['PTH']['func']}gallery.func.php";
require_once "{$GLOBALS['PTH']['classes']}gallery.class.php";

$Gallery = new TBL_Gallery;
$Section = new TBL_Section;

$perpage = getVar($GLOBALS['CONF']['gallery'], 'perpage', 15);
$page = getVar($_GET, 'page', '1');

//subsections
?>
<?php
$subsections = $Section->getChildren($cur_section);
foreach ($subsections as $subsection) {
    $title = $Section->getTValue($subsection, $sys_lang_id, 'title');
    $goto  = $GLOBALS['URL']['home'] . $Section->getPath($subsection);
    ?>
    <div><a href="<?php echo $goto?>"><?php echo $title?></a></div>
    <?php
}
?>
<?php

$num = count($Gallery->all("and `section`='$cur_section'"));
$pages = ceil($num / $perpage);
if ($page < 1) {
	$page = 1;
}
if ($page > $pages) {
	$page = $pages;
}
$start = ($page - 1) * $perpage;
$pictures = $Gallery->selectAll($start, $perpage, 'modified', 'desc', "and `section`='$cur_section' and `language`='$sys_lang_id'");

foreach ($pictures as $picture) {
	$image_path = $GLOBALS['PTH']['gallery'] . $picture['src'];
	$image_info = getImageSize($image_path);
	$size = preg_replace('/^.*(width)[^=]*(=)[^=\d]*([\d]+)[\D]*(height)[^=\d]*(=)[^=\d]*([\d]+)\D*$/i', '$1$2$3, $4$5$6', $image_info[3]);
	$dim = ($image_info[0] >= $image_info[1]) ? 'w' : 'h';
	$src = "{$GLOBALS['URL']['main']}thumbnail.php?module=gallery&amp;id={$picture['id']}&amp;w=100&amp;h=100";
	$link = "{$GLOBALS['URL']['main']}thumbnail.php?module=gallery&amp;id={$picture['id']}";
	?>
<div class="thumbnail">
    <a href="<?php echo $link?>" onClick="window.open('<?php echo $link?>', '', '<?php echo $size?>');return false;">
        <img src="<?php echo $src?>" alt="<?php echo $picture['title'][$sys_lang_id]?>">
    </a>
</div>
    <?php
}

    if ($pages > 1) {
        ?>
<div>
        <?php
        for ($i = 1; $i <= $pages; $i ++) {
            if ($i == $page) {
                ?><span class="page-active"><?php echo $i?></span><?php
            } else {
                ?><a href="?page=<?php echo $i?>" class="page-link"><?php echo $i?></a><?php
            }
        }
    ?>
</div>  
    <?php
    }

?>
</div>