<?php
/**
 * news.scr.php - Site news
 * Irokez CM script
 * 
 * @author Alexander Pak <irokez@gmail.com>
 * @copyright 2005 Alexander Pak
 * @license GNU/GPL <http://www.gnu.org/copyleft/gpl.html>
 */

require_once $GLOBALS['PTH']['classes'] . 'news.class.php';

$News   = new TBL_News;
$ICMTML = new ICM_TML;

$id      = getVar($GLOBALS['ENV']['extra'], 0);
$page    = getFormVar('page', '1');
$perpage = $GLOBALS['CONF']['news']['perpage'];

if (!empty($id) && $data = $News->select($id)) {
    $date = date4user($data['date'], $GLOBALS['CONF']['news']['date_format']);
    ?>
    
<h2><?php echo $data['title'][$sys_lang_id]?></h2>
<p class="date"><?php echo $date?></p>
<?php echo $data['text'][$sys_lang_id]?>
<a href="<?php echo $GLOBALS['URL']['this']?>?page=<?php echo $page?>"><?php echo $GLOBALS['LANG']['news']['back']?></a>

    <?php
} else {
    $num = count($News->all("and `section` = '$cur_section'"));
    $pages = ceil($num / $perpage);
    if ($page < 1) {
        $page = 1;
    }
    if ($page > $pages) {
        $page = $pages;
    }
    $start = ($page - 1) * $perpage;
    $news = $News->selectAll($start, $perpage, 'date', 'desc', "and `section` = '$cur_section'");
    foreach ($news as $data) {
        $date = date4user($data['date'], $GLOBALS['CONF']['news']['date_format']);
        $text = $ICMTML->parse($data['text'][$sys_lang_id]);
        $text = strip_tags($data['text'][$sys_lang_id], '<p><br><b><i><u><s>');
        $text = txt2short($text, $GLOBALS['CONF']['news']['short_num'], $GLOBALS['CONF']['news']['short_mode']);
        ?>
        
<p class="date"><?php echo $date?></p>
<?php echo $text?>
<a href="<?php echo $GLOBALS['URL']['this']?><?php echo $data['id']?>/?page=<?php echo $page?>"><?php echo $GLOBALS['LANG']['news']['more']?></a>
  
    <?php
    }

    if ($pages > 1) {
        ?>
        <?php
        for ($i = 1; $i <= $pages; $i ++) {
            if ($i == $page) {
                ?><span class="page-active"><?php echo $i?></span><?php
            } else {
                ?><a href="?page=<?php echo $i?>" class="page-link"><?php echo $i?></a><?php
            }
        }
    ?>
    <?php
    }
}

?>
