<?php
/*
    strtup.php - Startup file
    contains first settings and instructions for system startup
*/

/*
    define constants
*/
define('ROOT',    'root');
define('ACTIVE',  'active');
define('VIEW',    'view');
define('EDIT',    'edit');
define('DELETE',  'delete');
define('HOME',    'home');
define('HOME_ID', 1);

/*
    functions, required for startup
*/

function getmicrotime()
{ 
    list($usec, $sec) = explode(" ", microtime());
    return ((float)$usec + (float)$sec); 
}
/*
    extended parse_ini_file function
        variables can be used, e.g.: {$main}
    receives filename and process_section
    returnes array of data
*/
function xparse_ini_file($filename, $process_sections=false)
{
    $pre=parse_ini_file($filename, $process_sections);
    if(is_array(reset($pre)))
        foreach($pre as $section => $pre_by_section)
            foreach($pre_by_section as $key => $value)
            {
                preg_match_all('/\{\$(.+)\}/', $value, $vars, PREG_SET_ORDER);
                foreach($vars as $var)
                {
                    $var_name=$var[1];
                    if(isset($pre[$section][$var_name])) $var2replace=$pre[$section][$var_name];
                    elseif(isset($$var_name)) $var2replace=$$var_name;

                    if(isset($var2replace))
                        $pre[$section][$key]=str_replace('{$'.$var_name.'}', $var2replace, $value);
                }
            }
    else
        foreach($pre as $key => $value)
        {
            @preg_match_all('/\{\$(.+)\}/', $value, $vars, PREG_SET_ORDER);
            foreach($vars as $var)
            {
                $var_name=$var[1];
                if(isset($pre[$var_name])) $var2replace=$pre[$var_name];
                else eval("\$var2replace=\${$var_name};");
                /*
                 ^----- need to be changed!!!
                */

                if(isset($var2replace))
                    $pre[$key]=str_replace('{$'.$var_name.'}', $var2replace, $value);
            }
        }
    return $pre;
}

/*
    parse XML files
    receives file location
    returnes array of data
*/
function xparse_xml_file($fpath)
{
    $fcontent=file_get_contents($fpath);
/*    echo $fcontent;
    echo $fcontent=iconv('UTF-7', 'windows-1251', $fcontent);*/
    $parser=xml_parser_create();
    xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
    xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
    xml_parse_into_struct($parser, $fcontent, $values, $tags);
    $error=xml_get_error_code($parser);
    if($error)
    {
        $column=xml_get_current_column_number($parser);
        $line=xml_get_current_line_number($parser);
        $byte=xml_get_current_byte_index($parser);
        echo xml_error_string($error).' at line: '.$line.', column: '.$column.', byte: '.$byte."\n";
    }
    xml_parser_free($parser);
    $keys=array();
    $name='ini';
    foreach($values as $tag)
    {
        switch($tag['type'])
        {
            case 'open':
            case 'complete':
                array_push($keys, $tag['tag']);
                $e=&$$name;
                $last=array_pop($keys);
                foreach($keys as $key) $e=&$e[$key];
                array_push($keys, $last);
                if(isset($e[$last]))
                {
                    $last_k=(is_array($e[$last])) ? max(array_keys($e[$last])) : '';
                    if(!is_int($last_k))
                    {
                        $e=&$e[$last];
                        $b=$e;
                        $last=1;
                        $last_k=1;
                        $e=null;
                        $e[$last]=$b;
                    }
                    else $e=&$e[$last];
                    $last=$last_k+1;
                    array_push($keys, $last);
                }
                if($tag['type']=='complete')
                {
                    if(isset($tag['value']))
                    {
                        /*
                            variables {$var}
                        */
                        @preg_match_all('/\{\$(.+)\}/U', $tag['value'], $vars, PREG_SET_ORDER);
                        foreach($vars as $var)
                        {
                            $var_name=$var[1];
                            eval("\$var2replace=\${$var_name};");
                            /*
                             ^----- need to be changed!!!
                            */

                            if(isset($var2replace))
                                $tag['value']=str_replace('{$'.$var_name.'}', $var2replace, $tag['value']);
                        }

                        /*
                            functions {func()}
                        */
                        @preg_match_all('/\{(([\w_]+)\(.*\))\}/', $tag['value'], $funcs, PREG_SET_ORDER);
                        foreach($funcs as $func)
                        {
                            $func_body=$func[1];
                            $func_name=$func[2];
                            if(function_exists($func_name))
                            {
                                eval("\$var2replace={$func_body};");
                                /*
                                 ^----- need to be changed!!!
                                */

                                if($tag['value']==$func[0])
                                    $tag['value']=$var2replace;
                                else
                                    if(isset($var2replace))
                                        $tag['value']=str_replace('{'.$func_body.'}', $var2replace, $tag['value']);
                            }
                        }

                        /*
                            constants {const}
                        */
                        @preg_match_all('/\{(.+)\}/U', $tag['value'], $consts, PREG_SET_ORDER);
                        foreach($consts as $const)
                        {
                            $const_name=$const[1];
                            if(defined($const_name))
                            {
                                eval("\$var2replace={$const_name};");
                                /*
                                 ^----- need to be changed!!!
                                */

                                if(isset($var2replace))
                                    $tag['value']=str_replace('{'.$const_name.'}', $var2replace, $tag['value']);
                            }
                        }

                        switch($tag['value'])
                        {
                            case 'false':
                            case 'False':
                            case 'FALSE':
                                $e[$last]=false;
                                break;
                            case 'true':
                            case 'True':
                            case 'TRUE':
                                $e[$last]=true;
                                break;
                            case 'null':
                            case 'Null':
                            case 'NULL':
                                $e[$last]=null;
                                break;
                            default:
                            $e[$last]=$tag['value'];
                        }
                    }
                    else $e[$last]=null;
                    if(is_int(end($keys))) array_pop($keys);
                    array_pop($keys);
                }
                break;
            case 'close':
                if(is_int(end($keys))) array_pop($keys);
                array_pop($keys);
                break;
        }
    }
    return($ini);
}

class Timer
{
    var $start;
    var $points;
    var $time;
    var $total;
    var $precision;
    
    function Timer($start = true, $precision = 3)
    {
        $this->points = array();
        $this->time = array();
        $this->precision = (is_int($precision) && $precision >= 0 && $precision < 16) ? $precision : 3;
        if ($start) {
            $this->start();
        }
    }
    
    function start()
    {
        $this->start = $this->getmicrotime();
    }
    
    function stop($label = 'end')
    {
        $this->reg($label);
        $prev = $this->start;
        foreach ($this->points as $label => $point) {
            $this->time[$label] = number_format($point - $prev, $this->precision);
            $prev = $point;
        }
        $this->total = number_format($prev - $this->start, $this->precision);
    }

    function reg($label)
    {
        $this->points[$label] = $this->getmicrotime();
    }
    
    function getmicrotime()
    { 
        list($usec, $sec) = explode(" ", microtime());
        return ((float)$usec + (float)$sec); 
    }

    function report()
    {
        $report = '';
        $length = 20;
        $max_length = 0;
        $lines = array();
        foreach ($this->time as $label => $time) {
            $line = "$label: $time sec.";
            $lines[] = $line;
            if ($max_length < strlen($line)) {
                $max_length = strlen($line);
            }
        }
        
        foreach ($lines as $key => $line) {
            $lines[$key] = str_replace(':', str_pad(': ', $max_length - strlen($line) + $length + strlen("\n"), '.'), $line);
        }
        
        $report = implode("\n", $lines);
        $report .= str_pad("\n", $max_length + $length, '=');
        $total = "Total: $this->total sec.";
        $report .= str_replace(':', str_pad(': ', $max_length - strlen($total) + $length + strlen("\n"), '.'), "\n" . $total);
        return $report;
    }
}


?>