<?php
$GLOBALS['DB_LINK_NUM'] = 0;
$GLOBALS['DB_QUERY_NUM'] = 0;
$GLOBALS['DB_CACHED_QUERIES'] = array();
$GLOBALS['DB_CACHED_RESULTS'] = array();

include "startup.php";  //include startup file, contains first instructions

/*
    get config variables
*/
$GLOBALS += xparse_ini_file('path.conf', true);
$GLOBALS['CONF'] = xparse_ini_file("{$GLOBALS['PTH']['conf']}general.conf", true);

/*
    include class files
*/
require_once "{$GLOBALS['PTH']['classes']}icmtml.class.php";
require_once "{$GLOBALS['PTH']['classes']}session.class.php";
require_once "{$GLOBALS['PTH']['classes']}access.class.php";
require_once "{$GLOBALS['PTH']['classes']}section.class.php";
require_once "{$GLOBALS['PTH']['classes']}lang.class.php";
$GLOBALS['DB_CLASS_INSTANCE'] = new ICM_DB;

/*
    include function files
*/
require_once "{$GLOBALS['PTH']['func']}common.func.php";

$id = getFormVar('id');
$module = getFormVar('module');

ob_start();
switch ($module) {
    case 'gallery':
        include_once $GLOBALS['PTH']['classes'] . 'gallery.class.php';
        $Obj = new TBL_Gallery;
        $image_path = $GLOBALS['PTH']['gallery'] . getVar($Obj->select($id), 'src');
        break;
    default:
        $image_path = '';
}
$width_factor = getFormVar('w_f');
$height_factor = getFormVar('h_f');
$new_width = getFormVar('w');
$new_height = getFormVar('h');

if ($image_info = getImageSize($image_path)) {

	$width = $image_info[0];
	$height = $image_info[1];
	if (($width_factor || $height_factor) && !($new_width || $new_height)) {
		if ($width_factor && $height_factor) {
			$new_width = $width * $width_factor;
			$new_height = $height * $height_factor;
		}
	}

	if ($new_width || $new_height) {
		if ($new_width && $new_height) {
           $thumbnail_image = ImageCreateTrueColor($new_width, $new_height);
           $white = ImageColorAllocate($thumbnail_image, 255, 255, 255);
           ImageFilledRectangle($thumbnail_image, 0, 0, $new_width, $new_height, $white);

	       switch ($image_info[2]) {
                case IMG_GIF:
                    $source_image = ImageCreateFromGIF($image_path);
                    break;
                case IMG_JPG:
                    $source_image = ImageCreateFromJPEG($image_path);
                    break;
                case IMG_PNG:
                    $source_image = ImageCreateFromPNG($image_path);
                    break;
            }
    
            if ($width == $new_width && $height == $new_height) {
                ImageCopy($thumbnail_image, $source_image, 0, 0, 0, 0, $new_width, $new_height);
            } else if ($width > $new_width || $height > $new_height) {
                if ($width / $new_width < $height / $new_height) {
                    $factor = $new_width / $width;
                } else {
                    $factor = $new_height / $width;
                }
                $w = $width * $factor;
                $h = $height * $factor;
                $x = ($new_width - $w) / 2;
                $y = ($new_height - $h) / 2;
                ImageCopyResampled($thumbnail_image, $source_image, $x, $y, 0, 0, $w, $h, $width, $height);
            } else {
                $x = ($new_width - $width) / 2;
                $y = ($new_height - $height) / 2;
                ImageCopy($thumbnail_image, $source_image, $x, $y, 0, 0, $width, $height);
            }
            switch ($image_info[2]) {
                case IMG_GIF:
                    header('Content-Type: image/gif');
                    ImageGIF($thumbnail_image);
                    break;
                case IMG_JPG:
                    header('Content-Type: image/jpeg');
                    ImageJPEG($thumbnail_image);
                    break;
                case IMG_PNG:
                    header('Content-Type: image/png');
                    ImagePNG($thumbnail_image);
                    break;
            }
            exit;
		} elseif ($new_width) {
			$new_height = $height * ($new_width / $width);
		} elseif ($new_height) {
			$new_width = $width * ($new_height / $height);	
		} else false ;//no way, :) it's impossible
	} else {
		$new_width = $width;
		$new_height = $height;
	}
	ob_clean();
	switch ($image_info[2]) {
		case IMG_GIF: //gif
			header("Content-type: image/gif");
			$source_image = ImageCreateFromGIF($image_path);
			$thumbnail_image = ImageCreateTrueColor($new_width, $new_height);
			ImageCopyResampled($thumbnail_image, $source_image, 0, 0, 0, 0, $new_width, $new_height,$image_info[0],$image_info[1]);
			ImageGIF($thumbnail_image);
			break;
		case IMG_JPG: //jpeg
			header("Content-type: image/jpeg");
			$source_image = ImageCreateFromJPEG($image_path);
			$thumbnail_image = ImageCreateTrueColor($new_width, $new_height);
			ImageCopyResampled($thumbnail_image, $source_image, 0, 0, 0, 0, $new_width, $new_height,$image_info[0],$image_info[1]);
			ImageJPEG($thumbnail_image);
			break;
		case IMG_PNG: //png
			header("Content-type: image/png");
			$source_image = ImageCreateFromPNG($image_path);
			$thumbnail_image = ImageCreateTrueColor($new_width, $new_height);
			ImageCopyResampled($thumbnail_image, $source_image, 0, 0, 0, 0, $new_width, $new_height,$image_info[0],$image_info[1]);
			ImagePNG($thumbnail_image);
			break;
		default: //unsupported format
			break;
	}
}
?>