<?php
function tml_block($params)
{
    global
          $ICMTML,
          $Access,
          $Session,
          $Section,
          $Lang,
          $path,
          $sys_lang,
          $sys_lang_id,
          $act,
          $cur_section;

    //define available variables
    $type      = (isset($params['type'])) ? $params['type'] : '';
    $section   = (isset($params['section'])) ? $params['section'] : '';
    $delimiter = (isset($params['delimiter'])) ? $params['delimiter'] : '';
    
    if (!empty($section)) {
        $section_id = $Section->IdByPath(explode('/', $section));
        $section_data = $Section->select($section_id);
        $section_url = $GLOBALS['URL']['home'] . $Section->getPath($section_id);
    } else {
        $section_id = 0;
        $section_data = array();
        $section_url = '';
    }

    include_once $GLOBALS['PTH']['classes'] . 'block.class.php';
    
    $Block = new TBL_Block;
    if (!isset($GLOBALS['all_blocks'])) {
        $GLOBALS['all_blocks'] = $Block->selectAll();
        foreach ($GLOBALS['all_blocks'] as $block) {
            $GLOBALS['blocks_by_type'][$block['name']] = $block;
        }
    }
    $block = isset($GLOBALS['blocks_by_type'][$type]) ? $GLOBALS['blocks_by_type'][$type] : null;
    
    $HTML = '';
    switch($type) {
        /**********************************
        *          Bread crumbs           *
        **********************************/
        case 'breadcrumbs':
            $HTML = '';
            $first = true;
            $parents = $Section->getParents($cur_section);
            $parents = array_reverse($parents);
            array_push($parents, $cur_section);
            foreach ($parents as $parent) {
                $data = $Section->select($parent);
                $goto = $GLOBALS['URL']['home'] . $Section->getPath($parent);
                $delimiter2out = (!$first) ? $delimiter : '';
                $first = false;
                $HTML .=
<<<HTML
                      $delimiter2out<a href="$goto">{$data['title'][$sys_lang_id]}</a>
HTML;
            }
            break;
            
        /**********************************
        *          Search form            *
        **********************************/
        case 'search':
            if ($block) {
                $HTML .=
<<<HTML
        <form method="get" action="$section_url" id="quick-search">
            <input type="text" name="phrase" class="text" value="{$GLOBALS['LANG']['search']['title']}" title="{$GLOBALS['LANG']['search']['title']}"
              onFocus="if (this.value == this.getAttribute('title')) {this.value = ''}" onBlur="if (!this.value.length) {this.value = this.getAttribute('title')}" />
            <input type="image" src="{$GLOBALS['URL']['images']}search.gif" name="search" alt="{$GLOBALS['LANG']['search']['find']}" />
        </form>
HTML;
            }
            break;
            
        /**********************************
        *          Last news              *
        **********************************/
        case 'news':
            include_once $GLOBALS['PTH']['classes'] . 'news.class.php';
            
            $News = new TBL_News;
            $last_news = $News->selectAll(0, $GLOBALS['CONF']['news']['perblock'], 'date', 'desc', "and section='$section_id'");
            $HTML =
<<<HTML
        <h2>{$section_data['title'][$sys_lang_id]}</h2>
        <ul>
HTML;
            foreach ($last_news as $data) {
                $date = date4user($data['date']);
                $text = strip_tags($data['text'][$sys_lang_id], 'b i u s');
                $text = txt2short($data['text'][$sys_lang_id], $GLOBALS['CONF']['news']['short_num'], $GLOBALS['CONF']['news']['short_mode']);
                $HTML .=
<<<HTML
            <li>
                <p class="date">$date</p>
                $text
                <a href="{$section_url}{$data['id']}/">{$GLOBALS['LANG']['news']['more']}</a>
            </li>
HTML;
            }
            $HTML .=
<<<HTML
        </ul>
        <p class="more"><a href="$section_url">{$GLOBALS['LANG']['news']['all']}</a></p>
HTML;
            break;
            
        /**********************************
        *          Login form             *
        **********************************/
        case 'login':
            if ($Access->is_authorized($error)) {
                include_once $GLOBALS['PTH']['classes'] . 'user.class.php';
                $User = new TBL_User;
                $name = $User->getValue($User->id_by_login($Access->login), 'name');
                $HTML =
<<<HTML
        <form method="get" action="~logout">
            <p class="welcome">Welcome, {$name} (<a href="~logout">logout</a>)</p>
        </form>
HTML;
            } else {
                if (isset($GLOBALS['ENV']['login_error'])) {
                    $error = $GLOBALS['LANG']['login_err']['_' . $GLOBALS['ENV']['login_error']];
                    $login_msg =
<<<HTML
        <p class="error">{$error}</p>
HTML;
                } else {
                    $login_msg = '';
                }
                
                if (isset($_POST['login'])) {
                    $login = $_POST['login'];
                    $password = '';
                } else {
                    $login = $GLOBALS['LANG']['label']['login'];
                    $password = $GLOBALS['LANG']['label']['password'];
                }
                
                $HTML .=
<<<HTML
        <form method="post" action="?login">
            <input type="text" name="login" class="text" value="$login" title="{$GLOBALS['LANG']['label']['login']}"
             onFocus="if (this.value == this.getAttribute('title')) {this.value = ''}" onBlur="if (!this.value.length) {this.value = this.getAttribute('title')}" />
            <input type="password" name="pass" class="text" value="$password"  title="$password" 
             onFocus="if (this.value == this.getAttribute('title')) {this.value = ''}" onBlur="if (!this.value.length) {this.value = this.getAttribute('title')}" />
            <input type="submit" name="enter" value="{$GLOBALS['LANG']['label']['enter']}" />
            {$login_msg}
        </form>
HTML;
            }
            break;

        /*******************************
        *          Poll                *
        *******************************/
        case 'poll':
            include_once $GLOBALS['PTH']['classes'] . 'poll.class.php';
            if ($block) {
                $Poll = new TBL_Poll;
                $polls = $Poll->selectAll('date', 'desc', 0, 1);
                if (count($polls)) {
                    $poll = $polls[0];
                    
                    $HTML .=
<<<HTML
    <form action="$section_url?id={$poll['id']}&amp;vote=yes" method="post" id="quick-poll">
    <p>{$poll['question'][$sys_lang_id]}</p>
    <ul>
HTML;
                    $total = $Poll->totalVotes($poll['id']);
                    $max = $Poll->maxVotes($poll['id']);
                    $max_width = 150;
                    foreach ($poll['answers'] as $answer) {
                        if (isset($_COOKIE['voted' . $poll['id']])) {
                            $width = round($max_width * ($answer['votes'] / $max));
                            $HTML .=
<<<HTML
        <li>
            <div>{$answer['answer'][$sys_lang_id]}:</div>
            <div class="icm-polls-bar" style="width: {$width}px">{$answer['votes']}</div>
        </li>
HTML;
                            
                        } else {
                            $HTML .=
<<<HTML
        <li>
            <input type="radio" value="{$answer['id']}" name="answer" id="answer_{$answer['id']}" />
            <label for="answer_{$answer['id']}" class="vote">{$answer['answer'][$sys_lang_id]}</label>
        </li>
HTML;
                        }
                    }
                    if (!isset($_COOKIE['voted' . $poll['id']])) {
                        $HTML .=
<<<HTML
        </ul>
        <div>
            <input type="image" src="{$GLOBALS['URL']['images']}vote.gif" alt="{$GLOBALS['LANG']['polls']['vote']}" class="image" />
            <br /><a href="$section_url?id={$poll['id']}&amp;results=yes">{$GLOBALS['LANG']['polls']['results']}</a>
        </div>
HTML;
                    }
                } else {
                    $HTML .=
<<<HTML
    <div>{$GLOBALS['LANG']['polls']['no_polls']}</div>
HTML;
                }
                $HTML .=
<<<HTML
    </form>
HTML;

            }
            break;

        /*******************************
        *          Banners             *
        *******************************/
        case 'banners':
            if ($block) {
                include_once $GLOBALS['PTH']['classes'] . 'banner.class.php';
                $Banner = new TBL_Banner;
                $banners = $Banner->selectAll();
                /*if (strlen($block['title'][$sys_lang_id])) {
                    $HTML .=
<<<HTML
    <h2>{$block['title'][$sys_lang_id]}</h2>
HTML;
                }*/
                if (count($banners)) {
                    $HTML .=
<<<HTML
HTML;
                    foreach ($banners as $banner) {
                        $HTML .=
<<<HTML
    <div class="banner">
        <a href="{$banner['url']}" title="{$banner['title'][$sys_lang_id]}">
            <img src="{$GLOBALS['URL']['banners']}{$banner['src']}" alt="{$banner['title'][$sys_lang_id]}" />
        </a>
    </div>
HTML;
                    }
                    $HTML .=
<<<HTML
HTML;
                } else {
                    $HTML .= "<div>{$GLOBALS['LANG']['banners']['no_banners']}</div>";
                }
            }
            
            break;
            

        /*******************************
        *          Content block       *
        *******************************/
        case 'content':
            $section_id = $Section->IdByPath(explode('/', $section));
            $goto = $GLOBALS['URL']['home'] . $Section->getPath($section_id);
            $content = $Section->getTValue($section_id, $sys_lang_id, 'text');
            if (is_array($content) && count($content)) {
                $content = reset($content);
                $text = txt2short($content['text'][$sys_lang_id], 1, 'p');
                $HTML .=
<<<HTML
    <h2>{$content['title'][$sys_lang_id]}</h2>
    $text
    <p class="more"><a href="$section_url">{$GLOBALS['LANG']['news']['more']}</a>
HTML;
            }
            break;

        //add your blocks here
        case 'your-block-name':
            if ($block) {
                $HTML .= 'your block content';
            }
            break;
        default:
            if ($block) {
                $HTML .= $ICMTML->parse($block['text'][$sys_lang_id]);
            }
    }
    return $HTML;
}
?>