<?php
function tml_menu($params)
{
    global
          $Session,
          $Section,
          $Lang,
          $path,
          $sys_lang,
          $sys_lang_id,
          $act,
          $cur_section;
          
    //define available variables
    $type      = (isset($params['type'])) ? $params['type'] : '';
    $section   = (isset($params['section'])) ? $params['section'] : '';
    $delimeter = (isset($params['delimeter'])) ? $params['delimeter'] : '';

    $def_section_id = $Section->IdByNameNParent($GLOBALS['CONF']['def_section'], $Section->IdByNameNParent(HOME, 0));
    
    if (!empty($section)) {
        $section_id = $Section->IdByPath(explode('/', $section));
        $section_data = $Section->select($section_id);
        $section_url = $GLOBALS['URL']['home'] . $Section->getPath($section_id);
    } else {
        $section_id = 0;
        $section_data = array();
        $section_url = '';
    }
    
    include_once $GLOBALS['PTH']['classes'] . 'menu.class.php';
    $Menu = new TBL_Menu;
    if (!isset($GLOBALS['all_menus'])) {
        $GLOBALS['all_menus'] = $Menu->selectAll();
        foreach ($GLOBALS['all_menus'] as $menu) {
            $GLOBALS['menus_by_type'][$menu['name']] = $menu;
        }
    }
    $menu = isset($GLOBALS['menus_by_type'][$type]) ? $GLOBALS['menus_by_type'][$type] : null;

    $HTML = '';
    switch($type) {
        /**********************************
        *          Language menu          *
        **********************************/
        case 'lang':
            $langs = $Lang->selectAll();
            $first = true;
            foreach ($langs as $lang) {
                if ($lang['id'] != $sys_lang_id) {
                    $delimeter2out = (!$first) ? $delimeter : '';
                    $first = false;
                    $goto = $GLOBALS['URL']['main'] . $lang['name'] . $GLOBALS['ENV']['path'];
                    $title = $lang['title'][$lang['id']];
                    $HTML .=
<<<HTML
    $delimeter2out <a href="$goto">$title</a>
HTML;
                } else {
                    //current language
                }
            }
            break;

        /**********************************
        *          Sub-sections           *
        **********************************/
        case 'sub-sections':
            if ($menu) {
                $section = $cur_section;
                if (!count($Section->getChildren($cur_section))) {
                    $parent = $Section->getValue($cur_section, 'parent');
                    if ($parent != $Section->IdByNameNParent(HOME, 0)) {
                        $section = $parent;
                    }
                }
                $sections = $Section->selectAll(null, null, 'order', 'asc', "and parent='$section'");
                if (count($sections)) {
                    $HTML .=
<<<HTML
    <h1>{$menu['title'][$sys_lang_id]}</h1>
    <ul>
HTML;
                    foreach ($sections as $data) {
                        $goto = $GLOBALS['URL']['home'] . $Section->getPath($data['id']);
                        $HTML .=
<<<HTML
      <li><a href="$goto">{$data['title'][$sys_lang_id]}</a></li>
HTML;
                    }
                    $HTML .=
<<<HTML
    </ul>
HTML;
                }
            }
            break;

        /**********************************
        *          Left menu              *
        **********************************/
        case 'left':
            if ($menu) {
                $HTML .=
<<<HTML
<ul id="main-menu">
HTML;
                foreach ($menu['items'] as $item) {
                    $data = $Section->select($item['section']);
                    if ($data['id'] != $cur_section) {
                        $goto = $GLOBALS['URL']['home'] . $Section->getPath($data['id']);
                        $HTML .=
<<<HTML
    <li><a href="$goto">{$data['title'][$sys_lang_id]}</a></li>
HTML;
                        
                    } else {
                        $HTML .=
<<<HTML
    <li>{$data['title'][$sys_lang_id]}</li>
HTML;
                    }
                }
                $HTML .=
<<<HTML
</ul>
HTML;
            }
            break;

        /**********************************
        *          Icon menu              *
        **********************************/
        case 'shortcuts':
            if ($menu) {
                $HTML .=
<<<HTML
    <ul id="shortcuts">
HTML;
                foreach ($menu['items'] as $item) {
                    $data = $Section->select($item['section']);
                    if ($data['id'] != $cur_section) {
                        $goto = $GLOBALS['URL']['home'] . $Section->getPath($data['id']);
                        $HTML .=
<<<HTML
      <li><a href="$goto"><img src="{$GLOBALS['URL']['images']}{$data['name']}.gif" alt="{$data['title'][$sys_lang_id]}" /></a></li>
HTML;
                    } else {
                        $HTML .=
<<<HTML
      <li><img src="{$GLOBALS['URL']['images']}{$data['name']}-on.gif" alt="{$data['title'][$sys_lang_id]}" /></li>
HTML;
                    }
                }
                $HTML .=
<<<HTML
    </ul>
HTML;
            }
            break;
            
        /**********************************
        *          Modules drop-down      *
        **********************************/
        case 'modules':
            $admin_id = $Section->IdByPath(array(HOME, 'admin'));
            $sections = $Section->selectAll();
            $tree = sections_tree($sections);
            
            function draw_menu($name, $tree)
            {
                global $Section;
                $html = '';
                if (!strlen($name)) {
                    $name = 'untitled';
                }
                if (!is_array($tree)) {
                    return $name;
                } else {
                    $html .= $name;
                    $html .= count($tree) ? '<ul class="menu-builder-dropdown">' : '';
                    foreach ($tree as $key => $node) {
                        $title = $node['title'];
                        $name = $Section->getValue($key, 'name');
                        $title = '<a href="' . $GLOBALS['URL']['home'] . $Section->getPath($key) . '" class="menu-builder-dropdown menu-' . $name . '">' . $title . '</a>';
                        if (is_array($node)) {
                            unset($node['title']);
                            //branch
                            $html .= '<li class="menu-builder-dropdown">' . draw_menu($title, $node) . '</li>';
                        } else {
                            //leaf
                            $html .= '<li class="menu-builder-dropdown">' . draw_menu($title, 0) . '</li>';
                        }
                    }
                    $html .= count($tree) ? '</ul>' : '';
                }
                return $html;
            }

            $tree = $tree[$admin_id];
            unset($tree['title']);
            
            $HTML = '<ul class="menu-builder-horizontal">';
            foreach ($tree as $key => $branch) {
                $title = $branch['title'];
                    $title = '<a href="?id=' . $key . '" class="menu-builder-horizontal" onClick="return false">' . $title . '</a>';
                if (is_array($branch)) {
                    unset($branch['title']);
                    $HTML .= '<li class="menu-builder-horizontal">' . draw_menu($title, $branch) . '</li>';
                } else {
                    $HTML .= '<li class="menu-builder-horizontal">' . draw_menu($title, 0) . '</li>';
                }
            }
            $HTML .= '</ul>';
            
            break;

        /**********************************
        *          Sections tree          *
        **********************************/
        case 'sections':
            $sections = $Section->selectAll();
            $tree = sections_tree($sections);
            
            $HTML .= '<div id="sections-hint">' . $GLOBALS['LANG']['site']['sections_hint'] . '</div>';
            $HTML .= '<div class="tree">' . draw_tree($GLOBALS['LANG']['site']['title'], $tree) . '</div>';
            $HTML .= '<script type="text/javascript">closeAll(document.getElementById("sections-container"));</script>';
            break;
    }
    return $HTML;
}

function sections_tree($sections)
{
    global $sys_lang_id;
    
    $err_level = error_reporting();
    error_reporting(0);
    
    foreach ($sections as $key => $section) {
        $usefull = array(
            'id' => $section['id'],
            'order' => $section['order'],
            'parent' => $section['parent'],
            'title' => $section['title'][$sys_lang_id],
        );
        unset($sections[$key]);
        $sections[$key] = $usefull;
    }
    
    $sections_by_id = array('' => null);
    foreach ($sections as $section) {
        $sections_by_id[$section['id']] = $section;
    }
    foreach ($sections_by_id as $section) {
        $parent = $sections_by_id[$section['parent']];
        $parents = array($parent['id']);
        $elem = &$tree;
        while (!empty($parent['parent'])) {
            $parent = $sections_by_id[$parent['parent']];
            if (in_array($parent['id'], $parents)) {
                echo '!';
                break;
            }
            array_push($parents, $parent['id']);
        }
        
        if (end($parents)) {
            $parents[] = null;
        }
        $parents = array_reverse($parents);
        foreach ($parents as $parent) {
            if (!isset($elem[$parent])) {
                $elem[$parent] = array();
            }
            $elem = &$elem[$parent];
        }
        if (!isset($elem[$section['id']])) {
            $elem[$section['id']] = array();
        }
        if (!is_array($section)) {
            $section = array($section);
        }
        if (false) {
            $usefull = array(
                'id' => $section['id'],
                'title' => $section['title'],
            );
            unset($section);
            $section = $usefull;
        }
        
        $elem[$section['id']] = $elem[$section['id']] + array('title' => $section['title']);
    }
    $tree = reset($tree);
    unset($tree['']);
    $tree = reset($tree);
    unset($tree['title']);
    
    error_reporting($err_level);
    
    return $tree;
}

function cmp_order($a, $b)
{
    if ($a['order'] == $b['order']) {
        return 0;
    }
    return ($a['order'] < $b['order']) ? -1 : 1;
}

function usort_recursive(&$array, $func)
{
    if (is_array($array)) {
        foreach ($array as $key => $elem) {
            if (is_array($elem)) {
                if (is_array(reset($elem))) {
                    usort_recursive($array[$key], $func);
                } else {
                    usort($array[$key], $func);
                }
            }
        }
    }
}
//usort_recursive($tree, 'cmp_order');

function clear_tree($tree)
{
    $result = array();
    if (is_array($tree)) {
        
    }
}

function draw_tree($name, $tree)
{
    $html = '';
    if (!strlen($name)) {
        $name = 'untitled';
    }
    if (!is_array($tree)) {
        return $name;
    } else {
        $nodes_num = count($tree);
        $html .= $name;
        $html .= $nodes_num ? '<ul>' : '';
        $n = 0;
        foreach ($tree as $key => $node) {
            $n ++;
            $css_class = ($n == $nodes_num) ? 'last' : 'other';
            $title = '<a href="' . $GLOBALS['URL']['home'] . $GLOBALS['URL']['admin_sections'] . '~edit?id=' . $key . '">' . $node['title'] . '</a>';
            unset($node['title']);
            if (is_array($node)) {
                //branch
                $open = (empty($node)) ? '<div class="empty"></div>' : '<div class="opened" onClick="toggle(this)"></div>';
                $html .= '<li class="' . $css_class . '">' . $open . draw_tree($title, $node) . '</li>';
            } else {
                //leaf
                $html .= '<li class="' . $css_class . '"><div class="leaf"></div>' . draw_tree($title, 0) . '</li>';
            }
        }
        $html .= $nodes_num ? '</ul>' : '';
    }
    return $html;
}
?>